Encounter = class(Turbine.UI.Control)
function Encounter:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.MoralePower = {
        ["Morale"] = 1,
        ["Power"] = 2,
        ["Wrath"] = 3, --?
    }

    self.CombatStartTime = Turbine.Engine.GetGameTime()
    self.oldGameTime = Turbine.Engine.GetGameTime() - 1
    self.currentGameTime = Turbine.Engine.GetGameTime()
    self.date = Turbine.Engine.GetDate()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.trackWrath = self.player:GetClass() == Turbine.Gameplay.Class.Beorning

    if self.trackWrath then
        self.classAttribute = self.player:GetClassAttributes()
    end

    self:SetWantsUpdates(true)

    self.UpdateDelay = 1
    self.decimalPlaces = 1
    self.combatTime = 0
    self.currentCombatTime = 0
    --self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()

    -- Per seconds
    self.DPSMapped = {}
    self.TPSMapped = {}

    -- Skill Data
    self.SkillsMapped = {}
    self.ItemsMapped = {}
    self.SkillIcons = {}
    self.SkillDamage = {}
    self.SkillHits = {}
    self.SkillDamageTypes = {}
    self.SkillMaxDamage = {}
    self.SkillTotalHits = {}

    -- Target Skill Data
    self.TargetSkillsMapped = {}
    self.TargetItemsMapped = {}
    self.TargetSkillIcons = {}
    self.TargetSkillDamage = {}
    self.TargetSkillHits = {}
    self.TargetSkillDamageTypes = {}
    self.TargetSkillMaxDamage = {}
    self.TargetSkillTotalHits = {}

    -- Target Data
    self.TargetDamage = {}
    self.TargetHits = {}
    self.TargetDamageTypes = {}

    -- Misc tracking
    self.TargetBreakdown = {}
    self.PowerMapped = {}
    self.MoraleMapped = {}
    self.DamageMapped = {}
    self.DamageTakenMapped = {}
    self.HealingReceivedMapped = {}
    self.HealingAppliedMapped = {}
    self.WrathMapped = {}

    self.DamageBreakdownMapped = {}
    self.DamageTakenBreakdownMapped = {}
    self.HealingReceivedBreakdownMapped = {}
    self.HealingAppliedBreakdownMapped = {}

    self.DamageBreakdownMappedTarget = {}
    self.DamageTakenBreakdownMappedTarget = {}
    self.HealingReceivedBreakdownMappedTarget = {}
    self.HealingAppliedBreakdownMappedTarget = {}

    -- Corruptions
    self.CorruptionTotal = 0
    self.CorruptionBreakdown = {}
    self.CorruptionsTargetTotal = {}
    self.CorruptionTargetBreakdown = {}
    self.TargetCorruptionBreakdown = {}

    -- KBs
    self.KillingBlows = {}
    self.TotalKillingBlows = {}
    self.Kills = {}

    -- Damage taken
    self.TotalTakenHits = 0
    self.MaxDamageTaken = 0
    self.DamageTaken = 0
    self.PreviousDamageTaken = 0
    self.DamageTakenSkillMaxDamage = {}
    self.DamageTakenSkillTotalHits = {}
    self.DamageTakenSkills = {}
    self.DamageTakenTargets = {}
    self.DamageTakenTargetsSkillDamage = {}
    self.DamageTakenTargetsTotalHits = {}
    self.DamageTakenTargetsMaxDamage = {}

    self.DamageTakenType = {
        -- True damage - reflect 
        [""] = 0,

        -- Physical damages
        ["Common"] = 0,
        ["Ancient Dwarf-make"] = 0,
        ["Beleriand"] = 0,
        ["Fell-wrought"] = 0,
        ["Orc-craft"] = 0,
        ["Westernesse"] = 0,
        

        -- Tactical types
        ["Acid"] = 0,
        ["Fire"] = 0,
        ["Frost"] = 0,
        ["Light"] = 0,
        ["Lightning"] = 0,
        ["Shadow"] = 0,
        ["Morgul-forged"] = 0,
    }
    self.DamageTakenSkillsType = {}
    self.DamageTakenTargetSkillsType = {}
    self.DamageTakenTargetType = {}

    self.DamageTakenHitType = {
        [""] = 0,
        ["critical "] = 0,
        ["devastating "] = 0,
        ["partially blocked "] = 0,
        ["partially parried "] = 0,
        ["partially evaded "] = 0,
        ["blocked"] = 0,
        ["parried"] = 0,
        ["evaded"] = 0,
        ["resisted"] = 0,
        ["immune"] = 0,
        ["missed"] = 0,
    }
    self.DamageTakenSkillsHitType = {}
    self.DamageTakenTargetSkillsHitType = {}
    self.DamageTakenTargetHitType = {}

    -- Buffs
    self.Buffs = {}
    self.BuffsSource = {}
    self.BuffsTarget = {}
    self.BuffsApplied = {}

    -- Healing
    self.TemporaryMorale = 0
    self.TotalHealing = 0
    self.HealingHits = 0
    self.HealingReceived = {}
    self.HealingReceivedHitType = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.HealingReceivedSkillHitType = {}
    self.HealingRecievedSkillHits = {}

    self.HealingReceivedTotalTarget = {}
    self.HealingRecievedTargetHits = {}
    self.HealingRecievedTargetSkillHits = {}
    self.HealingReceivedSkillsTarget = {}
    self.HealingReceivedHitTypeTarget = {}
    self.HealingReceivedSkillsHitTypeTarget = {}


    self.PowerTotalHealing = 0
    self.PowerHealingHits = 0
    self.PowerHealingReceived = {}
    self.PowerHealingReceivedHitType = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.PowerHealingReceivedSkillHitType = {}
    self.PowerHealingRecievedSkillHits = {}

    self.PowerHealingReceivedTotalTarget = {}
    self.PowerHealingRecievedTargetHits = {}
    self.PowerHealingRecievedTargetSkillHits = {}
    self.PowerHealingReceivedSkillsTarget = {}
    self.PowerHealingReceivedHitTypeTarget = {}
    self.PowerHealingReceivedSkillsHitTypeTarget = {}

    -- Healing applied
    self.TotalHealingApplied = 0
    self.HealingHitsApplied = 0
    self.HealingReceivedApplied = {}
    self.HealingReceivedHitTypeApplied = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.HealingReceivedSkillHitTypeApplied = {}
    self.HealingRecievedSkillHitsApplied = {}

    self.HealingReceivedTotalTargetApplied = {}
    self.HealingRecievedTargetHitsApplied = {}
    self.HealingRecievedTargetSkillHitsApplied = {}
    self.HealingReceivedSkillsTargetApplied = {}
    self.HealingReceivedHitTypeTargetApplied = {}
    self.HealingReceivedSkillsHitTypeTargetApplied = {}

    
    self.PowerTotalHealingApplied = 0
    self.PowerHealingHitsApplied = 0
    self.PowerHealingReceivedApplied = {}
    self.PowerHealingReceivedHitTypeApplied = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.PowerHealingReceivedSkillHitTypeApplied = {}
    self.PowerHealingRecievedSkillHitsApplied = {}

    self.PowerHealingReceivedTotalTargetApplied = {}
    self.PowerHealingRecievedTargetHitsApplied = {}
    self.PowerHealingRecievedTargetSkillHitsApplied = {}
    self.PowerHealingReceivedSkillsTargetApplied = {}
    self.PowerHealingReceivedHitTypeTargetApplied = {}
    self.PowerHealingReceivedSkillsHitTypeTargetApplied = {}


    -- Damage types totals
    self.DamagetTypeData = {
        -- True damage - reflect 
        [""] = 0,

        -- Physical damages
        ["Common"] = 0,
        ["Ancient Dwarf-make"] = 0,
        ["Beleriand"] = 0,
        ["Fell-wrought"] = 0,
        ["Orc-craft"] = 0,
        ["Westernesse"] = 0,

        -- Tactical types
        ["Acid"] = 0,
        ["Fire"] = 0,
        ["Frost"] = 0,
        ["Light"] = 0,
        ["Lightning"] = 0,
        ["Shadow"] = 0,
        ["Morgul-forged"] = 0,
    }

    self.HitTypeData = {
        [""] = 0,
        ["critical "] = 0,
        ["devastating "] = 0,
        ["partially blocked "] = 0,
        ["partially parried "] = 0,
        ["partially evaded "] = 0,
        ["blocked"] = 0,
        ["parried"] = 0,
        ["evaded"] = 0,
        ["resisted"] = 0,
        ["immune"] = 0,
        ["missed"] = 0,

    }

    -- Totals
    self.CurrentTotalDamage = 0
    self.PreviousTotalDamage = 0
    self.PreviousHealingReceived = 0
    self.PreviousHealingApplied = 0
    self.Actions = 0
    self.ItemActions = 0
    self.MaxDamage = 0
    self.TotalHits = 0

    -- Contain all times when stack number of effects are added
    self.EffectStartTimes = {}

    -- Track stacks of effects
    self.EffectCounts = {}

    -- Encounterdata table
    self.EffectData = {}

    -- The same but for debuffs
    self.DebuffEffectData = {}
    self.DebuffTable = {}

    -- CCBreak
    self.CCCauseTable = {}
    self.CCCauseTargetTable = {}
    self.CCTargetTable = {}
    self.CCTargetCauseTable = {}

    -- Effect applied tracking
    self.EffectApplicationTimes = {}
    self.EffectRemovalTimes = {}

    self:Start()
end

function Encounter:UpdateDamage(damage, damageType, hitType, skillName, target)

    -- Update total
    self.CurrentTotalDamage = self.CurrentTotalDamage + damage

    -- Add to type totals
    self.DamagetTypeData[damageType] = self.DamagetTypeData[damageType] + damage

    -- Add to type totals
    self.TotalHits = self.TotalHits + 1
    self.HitTypeData[hitType] = self.HitTypeData[hitType] + 1

    -- Max damage
    if damage > self.MaxDamage then self.MaxDamage = damage end

    -- Skill damage saving
    self:AddSkillDamage(damage, skillName, damageType, hitType)

    -- Target damage saving
    self:AddTargetDamage(damage, skillName, damageType, hitType, target)

end

function Encounter:AddTargetDamage(damage, skillName, damageType, hitType, targetName)
    if not(self.TargetDamage[targetName]) then
        self.TargetDamage[targetName] = 0
        self.TargetHits[targetName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.TargetDamageTypes[targetName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
        self.TargetSkillDamage[targetName] = {}
        self.TargetSkillHits[targetName]= {}
        self.TargetSkillDamageTypes[targetName] = {}
    end

    self.TargetDamage[targetName] = self.TargetDamage[targetName] + damage
    self.TargetHits[targetName][hitType] = self.TargetHits[targetName][hitType] + 1
    self.TargetDamageTypes[targetName][damageType] = self.TargetDamageTypes[targetName][damageType] + damage

    self:AddTargetSkillDamage(damage, skillName, damageType, hitType, targetName)
end

function Encounter:AddSkillDamage(damage, skillName, damageType, hitType)
    if not(self.SkillDamage[skillName]) then
        self.SkillDamage[skillName] = 0
        self.SkillHits[skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.SkillDamageTypes[skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
        self.SkillMaxDamage[skillName] = 0
        self.SkillTotalHits[skillName] = 0
    end
    if damage > self.SkillMaxDamage[skillName] then self.SkillMaxDamage[skillName] = damage end
    self.SkillTotalHits[skillName] = self.SkillTotalHits[skillName] + 1
    self.SkillDamage[skillName] = self.SkillDamage[skillName] + damage
    self.SkillHits[skillName][hitType] = self.SkillHits[skillName][hitType] + 1
    self.SkillDamageTypes[skillName][damageType] = self.SkillDamageTypes[skillName][damageType] + damage

    if not self.DamageBreakdownMapped[self.currentCombatTime] then
        self.DamageBreakdownMapped[self.currentCombatTime] = {}
    end

    if not self.DamageBreakdownMapped[self.currentCombatTime][skillName] then
        self.DamageBreakdownMapped[self.currentCombatTime][skillName] = damage
    else
        self.DamageBreakdownMapped[self.currentCombatTime][skillName] = self.DamageBreakdownMapped[self.currentCombatTime][skillName] + damage
    end
end

function Encounter:AddTargetSkillDamage(damage, skillName, damageType, hitType, targetName)
    if not(self.TargetSkillDamage[targetName][skillName]) then
        self.TargetSkillDamage[targetName][skillName] = 0
        self.TargetSkillHits[targetName][skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.TargetSkillDamageTypes[targetName][skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
    end

    self.TargetSkillDamage[targetName][skillName] = self.TargetSkillDamage[targetName][skillName] + damage
    self.TargetSkillHits[targetName][skillName][hitType] = self.TargetSkillHits[targetName][skillName][hitType] + 1
    self.TargetSkillDamageTypes[targetName][skillName][damageType] = self.TargetSkillDamageTypes[targetName][skillName][damageType] + damage

    if not self.DamageBreakdownMappedTarget[self.currentCombatTime] then
        self.DamageBreakdownMappedTarget[self.currentCombatTime] = {}
    end

    if not self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName] then
        self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName] = {}
    end

    if not self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] then
        self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] = damage
    else
        self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] = self.DamageBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] + damage
    end
end

function Encounter:HandleCorruption(name, target)
    if not(self.CorruptionBreakdown[name]) then
        self.CorruptionBreakdown[name] = 0
    end

    self.CorruptionTotal = self.CorruptionTotal + 1

    self.CorruptionBreakdown[name] = self.CorruptionBreakdown[name] + 1

    -- Corruptoin -> target
    if not(self.CorruptionTargetBreakdown[name]) then
        self.CorruptionTargetBreakdown[name] = {}
    end

    if not(self.CorruptionsTargetTotal[target]) then
        self.CorruptionsTargetTotal[target] = 0
    end

    self.CorruptionsTargetTotal[target] = self.CorruptionsTargetTotal[target] + 1

    if not(self.CorruptionTargetBreakdown[name][target]) then
        self.CorruptionTargetBreakdown[name][target] = 0
    end

    self.CorruptionTargetBreakdown[name][target] = self.CorruptionTargetBreakdown[name][target] + 1


    -- Target -> corrutpion
    if not(self.TargetCorruptionBreakdown[target]) then
        self.TargetCorruptionBreakdown[target] = {}
    end

    if not(self.TargetCorruptionBreakdown[target][name]) then
        self.TargetCorruptionBreakdown[target][name] = 0
    end

    self.TargetCorruptionBreakdown[target][name] = self.TargetCorruptionBreakdown[target][name] + 1
end

function Encounter:UpdateKB(Source, Target)
    if not(self.KillingBlows[Source]) then
        self.KillingBlows[Source] = {}
        self.TotalKillingBlows[Source] = 0
    end

    self.TotalKillingBlows[Source] = self.TotalKillingBlows[Source] + 1

    if not(self.KillingBlows[Source][Target]) then
        self.KillingBlows[Source][Target] = 0
    end

    self.KillingBlows[Source][Target] = self.KillingBlows[Source][Target] + 1

    if not(self.Kills[Target]) then
        self.Kills[Target] = 0
    end

    self.Kills[Target] = self.Kills[Target] + 1

end

function Encounter:UpdateTakenDamage(damage, damageType, hitType, skillName, target)

    -- Update total
    self.DamageTaken = self.DamageTaken + damage

    -- Add to type totals
    self.DamageTakenType[damageType] = self.DamageTakenType[damageType] + damage

    -- Add to type totals
    self.TotalTakenHits = self.TotalTakenHits + 1
    self.DamageTakenHitType[hitType] = self.DamageTakenHitType[hitType] + 1

    -- Max damage
    if damage > self.MaxDamageTaken then self.MaxDamageTaken = damage end

    -- Skill damage saving
    self:AddSkillDamageTaken(damage, skillName, damageType, hitType)

    -- Target damage saving
    self:AddTargetDamageTaken(damage, skillName, damageType, hitType, target)

end

function Encounter:AddSkillDamageTaken(damage, skillName, damageType, hitType)
    if not(self.DamageTakenSkills[skillName]) then
        self.DamageTakenSkills[skillName] = 0
        self.DamageTakenSkillsHitType[skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenSkillsType[skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
        self.DamageTakenSkillMaxDamage[skillName] = 0
        self.DamageTakenSkillTotalHits[skillName] = 0
    end
    if damage > self.DamageTakenSkillMaxDamage[skillName] then self.DamageTakenSkillMaxDamage[skillName] = damage end
    self.DamageTakenSkillTotalHits[skillName] = self.DamageTakenSkillTotalHits[skillName] + 1
    self.DamageTakenSkills[skillName] = self.DamageTakenSkills[skillName] + damage
    self.DamageTakenSkillsHitType[skillName][hitType] = self.DamageTakenSkillsHitType[skillName][hitType] + 1
    self.DamageTakenSkillsType[skillName][damageType] = self.DamageTakenSkillsType[skillName][damageType] + damage

    if not self.DamageTakenBreakdownMapped[self.currentCombatTime] then
        self.DamageTakenBreakdownMapped[self.currentCombatTime] = {}
    end

    if not self.DamageTakenBreakdownMapped[self.currentCombatTime][skillName] then
        self.DamageTakenBreakdownMapped[self.currentCombatTime][skillName] = damage
    else
        self.DamageTakenBreakdownMapped[self.currentCombatTime][skillName] = self.DamageTakenBreakdownMapped[self.currentCombatTime][skillName] + damage
    end
end

function Encounter:AddTargetDamageTaken(damage, skillName, damageType, hitType, targetName)
    if not(self.DamageTakenTargets[targetName]) then
        self.DamageTakenTargets[targetName] = 0
        self.DamageTakenTargetHitType[targetName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenTargetType[targetName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
        self.DamageTakenTargetsSkillDamage[targetName] = {}
        self.DamageTakenTargetSkillsHitType[targetName]= {}
        self.DamageTakenTargetSkillsType[targetName] = {}
        self.DamageTakenTargetsTotalHits[targetName] = 0
        self.DamageTakenTargetsMaxDamage[targetName] = 0
    end

    if damage > self.DamageTakenTargetsMaxDamage[targetName] then self.DamageTakenTargetsMaxDamage[targetName] = damage end
    self.DamageTakenTargetsTotalHits[targetName] = self.DamageTakenTargetsTotalHits[targetName] + 1
    self.DamageTakenTargets[targetName] = self.DamageTakenTargets[targetName] + damage
    self.DamageTakenTargetHitType[targetName][hitType] = self.DamageTakenTargetHitType[targetName][hitType] + 1
    self.DamageTakenTargetType[targetName][damageType] = self.DamageTakenTargetType[targetName][damageType] + damage

    self:AddTargetSkillDamageTaken(damage, skillName, damageType, hitType, targetName)

    
    if not self.DamageTakenBreakdownMappedTarget[self.currentCombatTime] then
        self.DamageTakenBreakdownMappedTarget[self.currentCombatTime] = {}
    end

    if not self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName] then
        self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName] = {}
    end

    if not self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] then
        self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] = damage
    else
        self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] = self.DamageTakenBreakdownMappedTarget[self.currentCombatTime][targetName][skillName] + damage
    end

    
end

function Encounter:AddTargetSkillDamageTaken(damage, skillName, damageType, hitType, targetName)
    if not(self.DamageTakenTargetsSkillDamage[targetName][skillName]) then
        self.DamageTakenTargetsSkillDamage[targetName][skillName] = 0
        self.DamageTakenTargetSkillsHitType[targetName][skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenTargetSkillsType[targetName][skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
            ["Morgul-forged"] = 0,
        }
    end

    self.DamageTakenTargetsSkillDamage[targetName][skillName] = self.DamageTakenTargetsSkillDamage[targetName][skillName] + damage
    self.DamageTakenTargetSkillsHitType[targetName][skillName][hitType] = self.DamageTakenTargetSkillsHitType[targetName][skillName][hitType] + 1
    self.DamageTakenTargetSkillsType[targetName][skillName][damageType] = self.DamageTakenTargetSkillsType[targetName][skillName][damageType] + damage
end

function Encounter:HandleBuffsSource(Source, SkillName, Target)
    if not(self.Buffs[SkillName]) then
        self.Buffs[SkillName] = 0
    end

    self.Buffs[SkillName] = self.Buffs[SkillName] + 1

    if not(self.BuffsSource[SkillName]) then
        self.BuffsSource[SkillName] = {}
    end

    if not(self.BuffsSource[SkillName][Source]) then
        self.BuffsSource[SkillName][Source] = 0
    end

    self.BuffsSource[SkillName][Source] = self.BuffsSource[SkillName][Source] + 1
end

function Encounter:HandleBuffsTarget(Source, SkillName, Target)
    if not(self.BuffsApplied[SkillName]) then
        self.BuffsApplied[SkillName] = 0
    end

    self.BuffsApplied[SkillName] = self.BuffsApplied[SkillName] + 1

    if not(self.BuffsTarget[SkillName]) then
        self.BuffsTarget[SkillName] = {}
    end

    if not(self.BuffsTarget[SkillName][Target]) then
        self.BuffsTarget[SkillName][Target] = 0
    end

    self.BuffsTarget[SkillName][Target] = self.BuffsTarget[SkillName][Target] + 1
end

function Encounter:HandleHealingReceived(HitType, SkillName, Healing, Type, Source)
    if Type == "Morale" then
        self.TotalHealing = self.TotalHealing + Healing
        self.HealingHits = self.HealingHits + 1

        self.HealingReceivedHitType[HitType] = self.HealingReceivedHitType[HitType] + 1

        if not(self.HealingReceived[SkillName]) then
            self.HealingReceived[SkillName] = 0
            self.HealingRecievedSkillHits[SkillName] = 0
            self.HealingReceivedSkillHitType[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.HealingRecievedSkillHits[SkillName] = self.HealingRecievedSkillHits[SkillName] + 1
        self.HealingReceived[SkillName] = self.HealingReceived[SkillName] + Healing
        self.HealingReceivedSkillHitType[SkillName][HitType] = self.HealingReceivedSkillHitType[SkillName][HitType] + 1


        -- Target
        if not(self.HealingReceivedTotalTarget[Source]) then
            self.HealingReceivedTotalTarget[Source] = 0
            self.HealingRecievedTargetHits[Source] = 0
            self.HealingReceivedHitTypeTarget[Source] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingReceivedSkillsTarget[Source] = {}
            self.HealingReceivedSkillsHitTypeTarget[Source] = {}
            self.HealingRecievedTargetSkillHits[Source] = {}
        end
        self.HealingRecievedTargetHits[Source] = self.HealingRecievedTargetHits[Source] + 1
        self.HealingReceivedTotalTarget[Source] = self.HealingReceivedTotalTarget[Source] + Healing
        self.HealingReceivedHitTypeTarget[Source][HitType] = self.HealingReceivedHitTypeTarget[Source][HitType] + 1

        if not(self.HealingReceivedSkillsTarget[Source][SkillName]) then
            self.HealingReceivedSkillsTarget[Source][SkillName] = 0
            self.HealingReceivedSkillsHitTypeTarget[Source][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingRecievedTargetSkillHits[Source][SkillName] = 0
        end

        self.HealingRecievedTargetSkillHits[Source][SkillName] = self.HealingRecievedTargetSkillHits[Source][SkillName] + 1
        self.HealingReceivedSkillsTarget[Source][SkillName] = self.HealingReceivedSkillsTarget[Source][SkillName] + Healing
        self.HealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] = self.HealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] + 1    

        if not self.HealingReceivedBreakdownMapped[self.currentCombatTime] then
            self.HealingReceivedBreakdownMapped[self.currentCombatTime] = {}
        end
    
        if not self.HealingReceivedBreakdownMapped[self.currentCombatTime][SkillName] then
            self.HealingReceivedBreakdownMapped[self.currentCombatTime][SkillName] = Healing
        else
            self.HealingReceivedBreakdownMapped[self.currentCombatTime][SkillName] = self.HealingReceivedBreakdownMapped[self.currentCombatTime][SkillName] + Healing
        end

            
        if not self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime] then
            self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime] = {}
        end

        if not self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source] then
            self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source] = {}
        end

        if not self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source][SkillName] then
            self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source][SkillName] = Healing
        else
            self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source][SkillName] = self.HealingReceivedBreakdownMappedTarget[self.currentCombatTime][Source][SkillName] + Healing
        end

    elseif Type == "Power" then
        self.PowerTotalHealing = self.PowerTotalHealing + Healing
        self.PowerHealingHits = self.PowerHealingHits + 1

        self.PowerHealingReceivedHitType[HitType] = self.PowerHealingReceivedHitType[HitType] + 1

        if not(self.PowerHealingReceived[SkillName]) then
            self.PowerHealingReceived[SkillName] = 0
            self.PowerHealingRecievedSkillHits[SkillName] = 0
            self.PowerHealingReceivedSkillHitType[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.PowerHealingRecievedSkillHits[SkillName] = self.PowerHealingRecievedSkillHits[SkillName] + 1
        self.PowerHealingReceived[SkillName] = self.PowerHealingReceived[SkillName] + Healing
        self.PowerHealingReceivedSkillHitType[SkillName][HitType] = self.PowerHealingReceivedSkillHitType[SkillName][HitType] + 1


        -- Target
        if not(self.PowerHealingReceivedTotalTarget[Source]) then
            self.PowerHealingReceivedTotalTarget[Source] = 0
            self.PowerHealingRecievedTargetHits[Source] = 0
            self.PowerHealingReceivedHitTypeTarget[Source] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingReceivedSkillsTarget[Source] = {}
            self.PowerHealingReceivedSkillsHitTypeTarget[Source] = {}
            self.PowerHealingRecievedTargetSkillHits[Source] = {}
        end
        self.PowerHealingRecievedTargetHits[Source] = self.PowerHealingRecievedTargetHits[Source] + 1
        self.PowerHealingReceivedTotalTarget[Source] = self.PowerHealingReceivedTotalTarget[Source] + Healing
        self.PowerHealingReceivedHitTypeTarget[Source][HitType] = self.PowerHealingReceivedHitTypeTarget[Source][HitType] + 1

        if not(self.PowerHealingReceivedSkillsTarget[Source][SkillName]) then
            self.PowerHealingReceivedSkillsTarget[Source][SkillName] = 0
            self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingRecievedTargetSkillHits[Source][SkillName] = 0
        end

        self.PowerHealingRecievedTargetSkillHits[Source][SkillName] = self.PowerHealingRecievedTargetSkillHits[Source][SkillName] + 1
        self.PowerHealingReceivedSkillsTarget[Source][SkillName] = self.PowerHealingReceivedSkillsTarget[Source][SkillName] + Healing
        self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] = self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] + 1    
    end
end

function Encounter:HandleHealingApplied(HitType, SkillName, Healing, Type, Target)
    if Type == "Morale" then

        self.TotalHealingApplied = self.TotalHealingApplied + Healing
        self.HealingHitsApplied = self.HealingHitsApplied + 1

        self.HealingReceivedHitTypeApplied[HitType] = self.HealingReceivedHitTypeApplied[HitType] + 1

        if not(self.HealingReceivedApplied[SkillName]) then
            self.HealingReceivedApplied[SkillName] = 0
            self.HealingRecievedSkillHitsApplied[SkillName] = 0
            self.HealingReceivedSkillHitTypeApplied[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.HealingRecievedSkillHitsApplied[SkillName] = self.HealingRecievedSkillHitsApplied[SkillName] + 1
        self.HealingReceivedApplied[SkillName] = self.HealingReceivedApplied[SkillName] + Healing
        self.HealingReceivedSkillHitTypeApplied[SkillName][HitType] = self.HealingReceivedSkillHitTypeApplied[SkillName][HitType] + 1


        -- Target
        if not(self.HealingReceivedTotalTargetApplied[Target]) then
            self.HealingReceivedTotalTargetApplied[Target] = 0
            self.HealingRecievedTargetHitsApplied[Target] = 0
            self.HealingReceivedHitTypeTargetApplied[Target] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingReceivedSkillsTargetApplied[Target] = {}
            self.HealingReceivedSkillsHitTypeTargetApplied[Target] = {}
            self.HealingRecievedTargetSkillHitsApplied[Target] = {}
        end
        self.HealingRecievedTargetHitsApplied[Target] = self.HealingRecievedTargetHitsApplied[Target] + 1
        self.HealingReceivedTotalTargetApplied[Target] = self.HealingReceivedTotalTargetApplied[Target] + Healing
        self.HealingReceivedHitTypeTargetApplied[Target][HitType] = self.HealingReceivedHitTypeTargetApplied[Target][HitType] + 1

        if not(self.HealingReceivedSkillsTargetApplied[Target][SkillName]) then
            self.HealingReceivedSkillsTargetApplied[Target][SkillName] = 0
            self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] = 0
        end

        self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] = self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] + 1
        self.HealingReceivedSkillsTargetApplied[Target][SkillName] = self.HealingReceivedSkillsTargetApplied[Target][SkillName] + Healing
        self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] = self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] + 1    

        
        if not self.HealingAppliedBreakdownMapped[self.currentCombatTime] then
            self.HealingAppliedBreakdownMapped[self.currentCombatTime] = {}
        end
    
        if not self.HealingAppliedBreakdownMapped[self.currentCombatTime][SkillName] then
            self.HealingAppliedBreakdownMapped[self.currentCombatTime][SkillName] = Healing
        else
            self.HealingAppliedBreakdownMapped[self.currentCombatTime][SkillName] = self.HealingAppliedBreakdownMapped[self.currentCombatTime][SkillName] + Healing
        end

        if not self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime] then
            self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime] = {}
        end

        if not self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target] then
            self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target] = {}
        end

        if not self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target][SkillName] then
            self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target][SkillName] = Healing
        else
            self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target][SkillName] = self.HealingAppliedBreakdownMappedTarget[self.currentCombatTime][Target][SkillName] + Healing
        end

    elseif Type == "Power" then
        self.PowerTotalHealingApplied = self.PowerTotalHealingApplied + Healing
        self.PowerHealingHitsApplied = self.PowerHealingHitsApplied + 1

        self.PowerHealingReceivedHitTypeApplied[HitType] = self.PowerHealingReceivedHitTypeApplied[HitType] + 1

        if not(self.PowerHealingReceivedApplied[SkillName]) then
            self.PowerHealingReceivedApplied[SkillName] = 0
            self.PowerHealingRecievedSkillHitsApplied[SkillName] = 0
            self.PowerHealingReceivedSkillHitTypeApplied[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.PowerHealingRecievedSkillHitsApplied[SkillName] = self.PowerHealingRecievedSkillHitsApplied[SkillName] + 1
        self.PowerHealingReceivedApplied[SkillName] = self.PowerHealingReceivedApplied[SkillName] + Healing
        self.PowerHealingReceivedSkillHitTypeApplied[SkillName][HitType] = self.PowerHealingReceivedSkillHitTypeApplied[SkillName][HitType] + 1


        -- Target
        if not(self.PowerHealingReceivedTotalTargetApplied[Target]) then
            self.PowerHealingReceivedTotalTargetApplied[Target] = 0
            self.PowerHealingRecievedTargetHitsApplied[Target] = 0
            self.PowerHealingReceivedHitTypeTargetApplied[Target] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingReceivedSkillsTargetApplied[Target] = {}
            self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target] = {}
            self.PowerHealingRecievedTargetSkillHitsApplied[Target] = {}
        end
        self.PowerHealingRecievedTargetHitsApplied[Target] = self.PowerHealingRecievedTargetHitsApplied[Target] + 1
        self.PowerHealingReceivedTotalTargetApplied[Target] = self.PowerHealingReceivedTotalTargetApplied[Target] + Healing
        self.PowerHealingReceivedHitTypeTargetApplied[Target][HitType] = self.PowerHealingReceivedHitTypeTargetApplied[Target][HitType] + 1

        if not(self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName]) then
            self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] = 0
            self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] = 0
        end

        self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] = self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] + 1
        self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] = self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] + Healing
        self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] = self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] + 1    
    end
end

function Encounter:HandleSkillUse(skillname)
    if not self.SkillsMapped[skillname] then
        self.SkillsMapped[skillname] = {}
    end

    table.insert(self.SkillsMapped[skillname], self.currentGameTime - self.CombatStartTime)
end

function Encounter:EffectAdded(effect)
    -- Combine name and icon to avoid name conflicts
    local name = string.format("%s@@%s", effect:GetName(), effect:GetIcon())

    -- Create tables on first encounter
    if not(self.EffectStartTimes[name]) then
        self.EffectStartTimes[name] = {}
        self.EffectCounts[name] = 0
        self.EffectApplicationTimes[name] = {}
    end

    -- Add stack
    self.EffectCounts[name] = self.EffectCounts[name] + 1

    if self.EffectCounts[name] == 1 then
        table.insert(self.EffectApplicationTimes[name], self.currentGameTime - self.CombatStartTime)
    end

    -- Create uptime table
    if not(self.EffectStartTimes[name][self.EffectCounts[name]]) then
        self.EffectStartTimes[name][self.EffectCounts[name]] = 0
    end

    -- Set the start time of an effect for a specific stack
    self.EffectStartTimes[name][self.EffectCounts[name]] = Turbine.Engine.GetGameTime()

    if effect:IsDebuff() then
        self.DebuffTable[name] = true
    end
end

function Encounter:EffectRemoved(effect)
    local name = string.format("%s@@%s", effect:GetName(), effect:GetIcon())

    -- Add uptime to total (Application time till removal time)
    local newName = string.format("%s@@%s", name, self.EffectCounts[name])

    -- Debuff tracking
    if self.DebuffTable[name] then
        if not(self.DebuffEffectData[newName])  then
            self.DebuffEffectData[newName] = 0
        end
        self.DebuffEffectData[newName] = self.DebuffEffectData[newName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[name][self.EffectCounts[name]])
    else
        if not(self.EffectData[newName])  then
            self.EffectData[newName] = 0
        end
        self.EffectData[newName] = self.EffectData[newName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[name][self.EffectCounts[name]])
    end

    -- Reduce stack after completing bookkeeping
    self.EffectCounts[name] = self.EffectCounts[name] - 1

    if self.EffectCounts[name] == 0 then
        if not self.EffectRemovalTimes[name] then
            self.EffectRemovalTimes[name] = {}
        end

        table.insert(self.EffectRemovalTimes[name], self.currentGameTime - self.CombatStartTime)
    end
end

function Encounter:AddTemporaryMorale(Amount)
    self.TemporaryMorale = self.TemporaryMorale + Amount
end

function Encounter:GetTargetInfo()
    return self.TargetDamage, self.TargetHits, self.TargetDamageTypes
end

function Encounter:GetSkillInfo()
    return self.SkillDamage, self.SkillHits, self.SkillDamageTypes
end

function Encounter:HandleCCBreak(Culprit, Target, CCType)
    if not self.CCCauseTable[Culprit] then
        self.CCCauseTable[Culprit] = 0
    end
    self.CCCauseTable[Culprit] = self.CCCauseTable[Culprit] + 1

    if not self.CCCauseTargetTable[Culprit] then
        self.CCCauseTargetTable[Culprit] = {}
    end
    if not self.CCCauseTargetTable[Culprit][Target] then
        self.CCCauseTargetTable[Culprit][Target] = 0
    end
    self.CCCauseTargetTable[Culprit][Target] = self.CCCauseTargetTable[Culprit][Target] + 1

    if not self.CCTargetTable[Target] then
        self.CCTargetTable[Target] = 0
    end
    self.CCTargetTable[Target] = self.CCTargetTable[Target] + 1

    if not self.CCTargetCauseTable[Target] then
        self.CCTargetCauseTable[Target] = {}
    end
    if not self.CCTargetCauseTable[Target][Culprit] then
        self.CCTargetCauseTable[Target][Culprit] = 0
    end
    self.CCTargetCauseTable[Target][Culprit] = self.CCTargetCauseTable[Target][Culprit] + 1
end

function Encounter:Update()
    self.currentGameTime = Turbine.Engine.GetGameTime()
    if self.currentGameTime == self.oldGameTime then
        return(true)
    end
    local delta = self.currentGameTime - self.oldGameTime
    if delta < self.UpdateDelay then return end

    self.oldGameTime = numberRound(self.currentGameTime, self.decimalPlaces)

    if self.player:IsInCombat() then
        --self.CurrentItem = self.CurrentItem + 1

        self.currentCombatTime = numberRound(self.currentGameTime - self.CombatStartTime)
        self.combatTime = string.format("%ds", self.currentCombatTime)
        table.insert(self.DPSMapped, {self.combatTime, self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime)})
        table.insert(self.TPSMapped, {self.combatTime, self.DamageTaken / (Turbine.Engine.GetGameTime() - self.CombatStartTime)})
        table.insert(self.PowerMapped, {self.combatTime, self.player:GetPower()})
        table.insert(self.MoraleMapped, {self.combatTime, self.player:GetMorale()})
        table.insert(self.HealingReceivedMapped, {self.combatTime, self.TotalHealing - self.PreviousHealingReceived})
        table.insert(self.HealingAppliedMapped, {self.combatTime, self.TotalHealingApplied - self.PreviousHealingApplied})
        table.insert(self.DamageMapped, {self.combatTime, self.CurrentTotalDamage - self.PreviousTotalDamage})
        table.insert(self.DamageTakenMapped, {self.combatTime, self.DamageTaken - self.PreviousDamageTaken})

        if self.trackWrath then
            table.insert(self.WrathMapped, {self.combatTime, self.classAttribute:GetWrath()})
        end

        self.PreviousTotalDamage = self.CurrentTotalDamage
        self.PreviousDamageTaken = self.DamageTaken
        self.PreviousHealingReceived = self.TotalHealing
        self.PreviousHealingApplied = self.TotalHealingApplied

        --self.AdddamageContainerItem(self.DPSMapped[self.CurrentTimeStamp], currentGameTime)

        --smallPP:SetDPS(self.DPSMapped[self.oldGameTime])
        --ChatOutput(self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime) / 50000 * 200)
        --Online\Plugins\PrimePlugins\Parse\EncounterData.lua:314: attempt to perform arithmetic on field '?' (a nil value)
    end
end

function Encounter:Start()
    self:SetWantsUpdates(true)

    self.playerEffects = self.player:GetEffects()
    for i = 1, self.playerEffects:GetCount() do
        self:EffectAdded(self.playerEffects:Get(i))
    end

    self.effectAddedCallback = AddCallback(self.playerEffects, "EffectAdded", function(sender, args)
        self:EffectAdded(self.playerEffects:Get(args.Index))
    end)

    self.effectRemovedCallback = AddCallback(self.playerEffects, "EffectRemoved", function(sender, args)
        if args.Effect then
            self:EffectRemoved(args.Effect)
        end
    end)
end

function Encounter:Stop()
    self:SetWantsUpdates(false)

    self.CombatEndTime = Turbine.Engine.GetGameTime()

    RemoveCallback(self.playerEffects, "EffectAdded", self.effectAddedCallback)
    RemoveCallback(self.playerEffects, "EffectRemoved", self.effectRemovedCallback)

    for effectName, effectCount in pairs(self.EffectCounts) do
        if effectCount > 0 then
            for i = 1, effectCount do
                local longName = string.format("%s@@%s", effectName, i)
                if self.EffectStartTimes[effectName] and self.EffectStartTimes[effectName][self.EffectCounts[effectName]] then
                    if self.DebuffTable[effectName] then
                        if not(self.DebuffEffectData[longName]) then
                            self.DebuffEffectData[longName] = 0
                        end
                        self.DebuffEffectData[longName] = self.DebuffEffectData[longName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[effectName][self.EffectCounts[effectName]])
                    else
                        if not(self.EffectData[longName]) then
                            self.EffectData[longName] = 0
                        end
                        self.EffectData[longName] = self.EffectData[longName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[effectName][self.EffectCounts[effectName]])
                    end
                end

                if not self.EffectRemovalTimes[longName] then
                    self.EffectRemovalTimes[longName] = {}
                end
        
                table.insert(self.EffectRemovalTimes[longName], self.currentGameTime - self.CombatStartTime)
            end
        end
    end
end

function Encounter:GetTotalDamage()
    return self.CurrentTotalDamage
end

function Encounter:GetTotalCrit()
    return self.HitTypeData["critical "]
end

function Encounter:GetTotalCritPercentage()
    return self.HitTypeData["critical "] / self.TotalHits * 100
end

function Encounter:GetDPS()
    return self.DPSMapped[self.oldGameTime]
end

function Encounter:GetInformation()
    return self:GetData()
end

function Encounter:GetData()
    return {
        ["DPSMapped"] = self.DPSMapped,

        -- Skill Data
        ["SkillsMapped"] = self.SkillsMapped,
        ["ItemsMapped"] = self.ItemsMapped,
        ["SkillIcons"] = self.SkillIcons,
        ["SkillDamage"] = self.SkillDamage,
        ["SkillHits"] = self.SkillHits,
        ["SkillDamageTypes"] = self.SkillDamageTypes,
        ["SkillMaxDamage"] = self.SkillMaxDamage,
        ["SkillTotalHits"] = self.SkillTotalHits,

        -- Target Skill Data
        ["TargetSkillsMapped"] = self.TargetSkillsMapped,
        ["TargetItemsMapped"] = self.TargetItemsMapped,
        ["TargetSkillIcons"] = self.TargetSkillIcons,
        ["TargetSkillDamage"] = self.TargetSkillDamage,
        ["TargetSkillHits"] = self.TargetSkillHits,
        ["TargetSkillDamageTypes"] = self.TargetSkillDamageTypes,
        ["TargetSkillMaxDamage"] = self.SkillMaxDamage,
        ["TargetSkillTotalHits"] = self.SkillTotalHits,
    
        -- Target Data
        ["TargetDamage"] = self.TargetDamage,
        ["TargetHits"] = self.TargetHits,
        ["TargetDamageTypes"] = self.TargetDamageTypes,
    
        -- Misc tracking
        ["TargetBreakdown"] = self.TargetBreakdown,
        ["PowerMapped"] = self.PowerMapped,
        ["MoraleMapped"] = self.MoraleMapped,
        ["DamageMapped"] = self.DamageMapped,
    
        -- Damage types totals
        ["DamagetTypeData"] = self.DamagetTypeData,
    
        ["HitTypeData"] = self.HitTypeData,
    
        -- Totals
        ["CurrentTotalDamage"] = self.CurrentTotalDamage,
        ["Actions"] = self.Actions,
        ["ItemActions"] = self.ItemActions,
        ["MaxDamage"] = self.MaxDamage,
        ["TotalHits"] = self.TotalHits,

        ["CombatStartTime"] = self.CombatStartTime,
        ["Date"] = self.date,
    }
end

function Encounter:Unload()
    self:SetParent(nil)
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    for key, _ in pairs(self) do
        self[key] = nil
    end
    collectgarbage()
end

function Encounter:Output()

    --if true then return end
    local mapfunction = function(t)
        local result = {}
        for key, value in ipairs(t) do
            result[key] = value[2] or 0
        end
        return result
    end
    
    local outputString = "<parsedata>"
    outputString = string.format("%s<time>%s</time>", outputString, tablelength(self.MoraleMapped))
    outputString = string.format("%s<mapped>", outputString)
    
    outputString = string.format([[%s<data label='Total Damage Over Time'>%s</data>]], outputString, table.concat(mapfunction(self.DamageMapped), ","))
    outputString = string.format([[%s<data label='Damage Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.DPSMapped), ","))
    
    outputString = string.format([[%s<data label='Taken Damage Taken Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.TPSMapped), ","))
    outputString = string.format([[%s<data label='Total Damage Taken Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.DamageTakenMapped), ","))
    
    outputString = string.format([[%s<data label='Total Morale Over Time'>%s</data>]], outputString, table.concat(mapfunction(self.MoraleMapped), ","))
    if tablelength(self.WrathMapped) > 0 then
        outputString = string.format([[%s<data label='Total Wrath Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.WrathMapped), ","))
    else
        outputString = string.format([[%s<data label='Total Power Over Time'>%s</data>]], outputString, table.concat(mapfunction(self.PowerMapped), ","))
    end
    
    outputString = string.format([[%s<data label='Healing Applied Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.HealingAppliedMapped), ","))
    outputString = string.format([[%s<data label='Healing Received Per Second'>%s</data>]], outputString, table.concat(mapfunction(self.HealingReceivedMapped), ","))
    outputString = string.format("%s</mapped>", outputString)
    
    outputString = string.format("%s<metadata>", outputString)
    outputString = string.format("%s<class>%s</class>", outputString, self.player:GetClass())
    outputString = string.format("%s<class>%s</class>", outputString, "class")
    outputString = string.format("%s</metadata>", outputString)
    
    -- Effect applied bars
    outputString = string.format("%s<effects>", outputString)
    local startTime = self.CombatStartTime
    local combatTime = self.CombatEndTime - self.CombatStartTime
    for key, value in pairs(self.EffectStartTimes) do
        --<effect label="test_effect_1">12,30,55,60</effect>
        local effectName, _ = string.match(key, "(.*)@@(.*)")
        effectName = effectName:gsub("'", "")
        local timeString = string.format([[<e label='%s'>]], effectName)
        local effectString = {}
        for k, v in pairs(value) do
            table.insert(effectString, v - startTime)
            if self.EffectRemovalTimes[key] and self.EffectRemovalTimes[key][k] then
                table.insert(effectString, self.EffectRemovalTimes[key][k] or combatTime)
            else
                table.insert(effectString, combatTime)
            end
        end
        timeString = string.format("%s%s</e>", timeString, table.concat(effectString, ","))
    
        outputString = string.format("%s%s", outputString, timeString)
    end
    outputString = string.format("%s</effects>", outputString)

    -- Effect uptimes
    outputString = string.format("%s<effectuptimes>", outputString)
    for key, value in pairs(self.EffectData) do
        local effectName, _ = string.match(key, "(.*)@@(.*)")
        outputString = string.format("%s<eu label='%s'>%s</eu>", outputString, effectName:gsub("'", ""), tonumber(value) and tonumber(value)/combatTime*100 or 0)
    end
    outputString = string.format("%s</effectuptimes>", outputString)

    local tableFunction = function(totalString, T, keyword)
        for k, v in pairs(T) do
            totalString = string.format("%s<%s label = '%s'>%s</%s>", outputString, keyword, k:gsub("'", ""), v, keyword)
        end
        return totalString
    end

    -- Skill use
    outputString = string.format("%s<skillusage>", outputString)
    for key, value in pairs(self.SkillsMapped) do
        outputString = string.format([[%s<data label='%s'>%s</data>]], outputString, key:gsub("'", ""), table.concat(value, ","))
    end
    outputString = string.format("%s</skillusage>", outputString)

    -- Damage breakdown
    local breakdownFunction = function(T, name)
        outputString = string.format("%s<timebreakdown label = '%s'>", outputString, name)
        for key, value in pairs(T) do
            outputString = string.format("%s<time label='%s'>", outputString, key)
            for k, v in pairs(value) do
                outputString = string.format("%s<value label='%s'>%s</value>", outputString, k:gsub("'", ""), v)
            end
            outputString = string.format("%s</time>", outputString)
        end
        outputString = string.format("%s</timebreakdown>", outputString)

    end
    outputString = string.format("%s<timebreakdowns>", outputString)
    breakdownFunction(self.DamageBreakdownMapped, "Damage Breakdown")
    breakdownFunction(self.DamageTakenBreakdownMapped, "Damage Taken Breakdown")
    breakdownFunction(self.HealingReceivedBreakdownMapped, "Healing Received Breakdown")
    breakdownFunction(self.HealingAppliedBreakdownMapped, "Healing Applied Breakdown")
    outputString = string.format("%s</timebreakdowns>", outputString)

    -- Skill Damage
    outputString = string.format("%s<skilldamages>", outputString)
    for key, value in pairs(self.SkillDamage) do
        outputString = string.format("%s<skilldamage label='%s'>", outputString, key:gsub("'", ""))
        outputString = tableFunction(outputString, self.SkillHits[key], "hittype")
        outputString = tableFunction(outputString, self.SkillDamageTypes[key], "damagetype")
        outputString = string.format("%s<totaldamage>%s</totaldamage>", outputString, tonumber(value))
        outputString = string.format("%s</skilldamage>", outputString)
    end
    outputString = string.format("%s</skilldamages>", outputString)

    -- Target Skill Damage
    outputString = string.format("%s<targetskilldamages>", outputString)
    for key, value in pairs(self.TargetSkillDamage) do
        outputString = string.format("%s<sdt label='%s'>", outputString, key:gsub("'", ""))
        for k2, v2 in pairs(value) do
            outputString = string.format("%s<sdtv label = '%s'>", outputString, k2:gsub("'", ""))
            outputString = tableFunction(outputString, self.TargetSkillHits[key][k2], "hittype")
            outputString = tableFunction(outputString, self.TargetSkillDamageTypes[key][k2], "damagetype")
            outputString = string.format("%s<totaldamage>%s</totaldamage>", outputString, tonumber(v2))
            outputString = string.format("%s</sdtv>", outputString)
        end
        outputString = string.format("%s</sdt>", outputString)
    end
    outputString = string.format("%s</targetskilldamages>", outputString)

    -- Skill Damage Taken
    outputString = string.format("%s<takenskilldamages>", outputString)
    for key, value in pairs(self.DamageTakenSkills) do
        outputString = string.format("%s<takenskilldamage label='%s'>", outputString, key:gsub("'", ""))
        outputString = tableFunction(outputString, self.DamageTakenSkillsHitType[key], "hittype")
        outputString = tableFunction(outputString, self.DamageTakenSkillsType[key], "damagetype")
        outputString = string.format("%s<totaldamage>%s</totaldamage>", outputString, tonumber(value))
        outputString = string.format("%s</takenskilldamage>", outputString)
    end
    outputString = string.format("%s</takenskilldamages>", outputString)

    -- Skill Damage Taken target
    outputString = string.format("%s<takentargetskilldamages>", outputString)
    for key, value in pairs(self.DamageTakenTargetsSkillDamage) do
        outputString = string.format("%s<ttsdt label='%s'>", outputString, key:gsub("'", ""))
        for k2, v2 in pairs(value) do
            outputString = string.format("%s<ttsd label='%s'>", outputString, k2:gsub("'", ""))
            outputString = tableFunction(outputString, self.DamageTakenTargetSkillsHitType[key][k2], "hittype")
            outputString = tableFunction(outputString, self.DamageTakenTargetSkillsType[key][k2], "damagetype")
            outputString = string.format("%s<totaldamage>%s</totaldamage>", outputString, tonumber(v2))
            outputString = string.format("%s</ttsd>", outputString)
        end
        outputString = string.format("%s</ttsdt>", outputString)
    end
    outputString = string.format("%s</takentargetskilldamages>", outputString)

    -- Breakdowns
    local breakdownFunction = function(label1, label2, T)
        outputString = string.format("%s<%s>", outputString, label1)
        for combatTime, breakdownList in pairs(T) do
            outputString = string.format("%s<%s label='%s'>", outputString, label2, combatTime)
            for skillName, v in pairs(breakdownList) do
                outputString = string.format("%s<skill label='%s'>%s</skill>", outputString, skillName:gsub("'", ""), v)
            end
            outputString = string.format("%s</%s>", outputString, label2)    
        end
        outputString = string.format("%s</%s>", outputString, label1)    
    end

    outputString = string.format("%s<breakdowns>", outputString)
    breakdownFunction("db", "dbm", self.DamageBreakdownMapped)
    breakdownFunction("hab", "habm", self.HealingAppliedBreakdownMapped)
    breakdownFunction("hrb", "hrbm", self.HealingReceivedBreakdownMapped)
    breakdownFunction("tdb", "tdbm", self.DamageTakenBreakdownMapped)
    outputString = string.format("%s</breakdowns>", outputString)

    local targetBreakdownFunction = function(label1, label2, T)
        outputString = string.format("%s<%s>", outputString, label1)
        for combatTime, targetList in pairs(T) do
            outputString = string.format("%s<%s label='%s'>", outputString, label2, combatTime)
            for targetName, breakdownList in pairs(targetList) do
                outputString = string.format("%s<target label='%s'>", outputString, targetName:gsub("'", ""))
                for skillName, v in pairs(breakdownList) do
                    outputString = string.format("%s<skill label='%s'>%s</skill>", outputString, skillName:gsub("'", ""), v)
                end
                outputString = string.format("%s</target>", outputString, skillName, v)
            end
            outputString = string.format("%s</%s>", outputString, label2)    
        end
        outputString = string.format("%s</%s>", outputString, label1)    
    end

    outputString = string.format("%s<targetbreakdowns>", outputString)
    targetBreakdownFunction("tdb", "tdbm", self.DamageBreakdownMappedTarget)
    targetBreakdownFunction("thab", "thabm", self.HealingAppliedBreakdownMappedTarget)
    targetBreakdownFunction("thrb", "thrbm", self.HealingReceivedBreakdownMappedTarget)
    targetBreakdownFunction("ttdb", "ttdbm", self.DamageTakenBreakdownMappedTarget)
    outputString = string.format("%s</targetbreakdowns>", outputString)

    outputString = string.format("%s</parsedata>", outputString)

    SaveTable(Turbine.DataScope.Account, string.format("parse%s",  math.floor(self.CombatStartTime)), {["Output"] = outputString})
end