PlayerSkillEvents = class()
function PlayerSkillEvents:Constructor()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.trainedSkills = self.player:GetTrainedSkills()

    self.PlayerSkills = {}
    self.skillCallbacks = {}


    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)
        local name = string.format("%s@@%s", item:GetSkillInfo():GetName(), item:GetSkillInfo():GetIconImageID())

        self.PlayerSkills[name] = item
        self.skillCallbacks[name] =  AddCallback(self.PlayerSkills[name], "ResetTimeChanged", function(sender, args) 
            if CombatHandlerObject then
                local time = self.PlayerSkills[name]:GetResetTime() - Turbine.Engine.GetGameTime()
                if time + 0.1 > self.PlayerSkills[name]:GetCooldown() then
                    CombatHandlerObject:HandleSkillUse(name)
                end
            end
        end)
    end
end

function PlayerSkillEvents:RemoveCallbacks()
    for name, callback in pairs(self.skillCallbacks) do
        RemoveCallback(self.playerSkills[name], "ResetTimeChanged", callback)
        self.skillCallbacks[name] = nil
    end
end