LembasClickerWindow = class(Turbine.UI.Lotro.Window)
function LembasClickerWindow:Constructor(loadedData)
    local width = 900
    local height = 492
    local x = Settings.LOX - 125
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(width, height)
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - width / 2 , Turbine.UI.Display.GetHeight() / 2  - height / 2)
    self:SetWantsKeyEvents(true)
    self:SetVisible(true)
    self:SetText("Lembas Clicker")

	self.clickBorderColour = Turbine.UI.Color.Black
	self.clickBackgroundColour = Turbine.UI.Color.DarkCyan
	self.clickBorderSize = 2
	self.BuildingBorderColour = Turbine.UI.Color.White
	self.BuildingBackgroundColour = Turbine.UI.Color.Black

	self.buildingBorderSize = 2

	self.ClickContainer = Turbine.UI.Control()
	self.ClickContainer:SetParent(self)
	self.ClickContainer:SetSize(self:GetWidth()/3 * 2, self:GetHeight())
	self.ClickContainer:SetPosition(0, 0)
	self.ClickContainer:SetBackground(0x411EAD0C)

	self.ClickBorder = Turbine.UI.Control()
	self.ClickBorder:SetParent(self.ClickContainer)
	self.ClickBorder:SetSize(self.ClickContainer:GetWidth(), self.ClickContainer:GetHeight())
	--self.ClickBorder:SetBackColor(self.clickBorderColour)

	self.ClickBackground = Turbine.UI.Control()
	self.ClickBackground:SetParent(self.ClickBorder)
	self.ClickBackground:SetSize(self.ClickBorder:GetWidth() - 2 * self.clickBorderSize, self.ClickBorder:GetHeight() - 2 * self.clickBorderSize)
	self.ClickBackground:SetPosition(self.clickBorderSize, self.clickBorderSize)
	--self.ClickBackground:SetBackColor(self.clickBackgroundColour)

	--[[ 0x410FC45B Light lembas--]] 
	-- [[0x410FC459 dark lembas--]]
	self.Lembas = Turbine.UI.Control()
	self.Lembas:SetParent(self.ClickBackground)
	self.Lembas:SetBackground(0x410FC45B)
	self.Lembas:SetStretchMode(2)
	self.Lembas:SetStretchMode(1)
	self.Lembas:SetSize(100, 100)
	self.Lembas:SetMouseVisible(true)
	self.Lembas:SetPosition(self.ClickBackground:GetWidth() / 2 - 100 / 2, self.ClickBackground:GetHeight() / 2 - 50)

	self.Lembas.MouseClick = function()
		self:LembasClick()
	end

	self.LembasCountBackground = Turbine.UI.Control()
	self.LembasCountBackground:SetParent(self.ClickBackground)
	self.LembasCountBackground:SetPosition(0, self.ClickBackground:GetHeight() / 5)
	self.LembasCountBackground:SetSize(self.ClickBackground:GetWidth(), 60)
	self.LembasCountBackground:SetBackColor(Turbine.UI.Color(0.5, 0, 0, 0))
	self.LembasCountBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

	self.LembasCountTotal = Turbine.UI.Label()
	self.LembasCountTotal:SetParent(self.LembasCountBackground)
	self.LembasCountTotal:SetSize(self.LembasCountBackground:GetWidth(), 40)
	self.LembasCountTotal:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.LembasCountTotal:SetOutlineColor(Turbine.UI.Color.Black)
	self.LembasCountTotal:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
	self.LembasCountTotal:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.LembasCountTotal:SetForeColor(Turbine.UI.Color.White)

	self.LembasPerSecond = Turbine.UI.Label()
	self.LembasPerSecond:SetParent(self.LembasCountBackground)
	self.LembasPerSecond:SetSize(self.LembasCountBackground:GetWidth(), self.LembasCountBackground:GetHeight() - self.LembasCountTotal:GetHeight())
	self.LembasPerSecond:SetPosition(0, self.LembasCountTotal:GetHeight())
	self.LembasPerSecond:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.LembasPerSecond:SetOutlineColor(Turbine.UI.Color.Black)
	self.LembasPerSecond:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
	self.LembasPerSecond:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.LembasPerSecond:SetForeColor(Turbine.UI.Color.White)

	self.BuildingContainer = Turbine.UI.Control()
	self.BuildingContainer:SetParent(self)
	self.BuildingContainer:SetSize(self:GetWidth() - self.ClickContainer:GetWidth(), self:GetHeight())
	self.BuildingContainer:SetPosition(self.ClickContainer:GetWidth(), 0)

	self.BuildingBorder = Turbine.UI.Control()
	self.BuildingBorder:SetParent(self.BuildingContainer)
	self.BuildingBorder:SetSize(self.BuildingContainer:GetWidth(), self.BuildingContainer:GetHeight())
	self.BuildingBorder:SetBackColor(self.BuildingBorderColour)

	self.BuildingBackground = Turbine.UI.Control()
	self.BuildingBackground:SetParent(self.BuildingBorder)
	self.BuildingBackground:SetSize(self.BuildingBorder:GetWidth() - 2 * self.buildingBorderSize, self.BuildingBorder:GetHeight() - 2 * self.buildingBorderSize)
	self.BuildingBackground:SetPosition(self.buildingBorderSize, self.buildingBorderSize)
	self.BuildingBackground:SetBackColor(self.BuildingBackgroundColour)

	self.BuildingAndUpgradesTreeview = Turbine.UI.TreeView()
	self.BuildingAndUpgradesTreeview:SetParent(self.BuildingBackground)
	self.BuildingAndUpgradesTreeview:SetSize(self.BuildingBackground:GetWidth(), self.BuildingBackground:GetHeight())
	self.BuildingAndUpgradesTreeview:SetIndentationWidth(0)
	self.BuildingAndUpgradesTreeview:SetBackColor(Turbine.UI.Color.Black)
	self.BuildingAndUpgradesTreeviewNodes = self.BuildingAndUpgradesTreeview:GetNodes()

	self.UpgradeNode = Turbine.UI.TreeNode()
	self.UpgradeNode:SetSize(self.BuildingAndUpgradesTreeview:GetWidth(), 120)

	self.UpgradeNodeUpgradeLabel = Turbine.UI.Label()
	self.UpgradeNodeUpgradeLabel:SetParent(self.UpgradeNode)
	self.UpgradeNodeUpgradeLabel:SetSize(self.UpgradeNode:GetWidth(), 20)
	self.UpgradeNodeUpgradeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.UpgradeNodeUpgradeLabel:SetOutlineColor(Turbine.UI.Color.Black)
	self.UpgradeNodeUpgradeLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.UpgradeNodeUpgradeLabel:SetForeColor(Turbine.UI.Color.White)
	self.UpgradeNodeUpgradeLabel:SetText("Upgrades")

	self.UpgradeListbox = Turbine.UI.ListBox()
	self.UpgradeListbox:SetParent(self.UpgradeNode)
	--self.UpgradeListbox:SetBackColor(Turbine.UI.Color.Red)
	self.UpgradeListbox:SetPosition(0, self.UpgradeNodeUpgradeLabel:GetHeight())
	self.UpgradeListbox:SetSize(self.UpgradeNode:GetWidth() - 10, 100)

	self.UpgradeListboxScrollbar = Turbine.UI.Lotro.ScrollBar()
	self.UpgradeListboxScrollbar:SetParent(self.UpgradeNode)
	self.UpgradeListboxScrollbar:SetSize(10, self.UpgradeNode:GetHeight())
	self.UpgradeListboxScrollbar:SetPosition(self.UpgradeListbox:GetWidth() , 0)
	self.UpgradeListboxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
	self.UpgradeListbox:SetVerticalScrollBar(self.UpgradeListboxScrollbar)

	
	self.BuildingAndUpgradesTreeviewNodes:Add(self.UpgradeNode)

	self.BuildingNode = Turbine.UI.TreeNode()
	self.BuildingNode:SetSize(self.BuildingAndUpgradesTreeview:GetWidth(), 420)


	self.BuildingAndUpgradesTreeview:ExpandAll()

	self.BuildingNodeUpgradeLabel = Turbine.UI.Label()
	self.BuildingNodeUpgradeLabel:SetParent(self.BuildingNode)
	self.BuildingNodeUpgradeLabel:SetSize(self.BuildingNode:GetWidth(), 20)
	self.BuildingNodeUpgradeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.BuildingNodeUpgradeLabel:SetOutlineColor(Turbine.UI.Color.Black)
	self.BuildingNodeUpgradeLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.BuildingNodeUpgradeLabel:SetForeColor(Turbine.UI.Color.White)
	self.BuildingNodeUpgradeLabel:SetText("Buildings")

	self.BuildingListbox = Turbine.UI.ListBox()
	self.BuildingListbox:SetParent(self.BuildingNode)
	self.BuildingListbox:SetBackColor(Turbine.UI.Color.Black)
	self.BuildingListbox:SetSize(self.BuildingNode:GetWidth(), 400)
	self.BuildingListbox:SetPosition(0, self.BuildingNodeUpgradeLabel:GetHeight())

	self.CloseButton = Turbine.UI.Control()
	self.CloseButton:SetParent(self)
	self.CloseButton:SetSize(10, 10)
	self.CloseButton:SetPosition(self:GetWidth() - 10, 0)
	self.CloseButton:SetBackColor(Turbine.UI.Color.Red)
	self.CloseButton.MouseClick = function()
		self:SetVisible(false)
	end

	self.BuildingAndUpgradesTreeviewNodes:Add(self.BuildingNode)
	self.buildings = Compression:StringToTable("JXScZj)sm3utYTmloJulYjpto)80Wrjn(Mn5uIfNQZ5xCjYViNZjZKZoSeZP0udGzd0ZKM8jGGHZZOWUaJBYJ8tkPmlrbpYpNuVaZA4OaVCdxGLtEbwz8cSXkqPnYZ8YdKWsAuAxGLJ4cyXveO4fiqO5MuIfPqifLykPQqWzKzbGvLXfCbw4qVhawz7fOYoKR5uwQ5PGB5xuQfxcivir6QEbwKGXFFbWkPffaPgxkpXIaPkFZmpWobHf4IWutMxGngb8")
	self.upgrades = Compression:StringToTable("DrzWVnXryuCBhVrXkuvZblciq9JejIRqfXPkKIqQRTJDd4n241qi5sZ4DNyp4zNzz2XXyoLdCajoXLkupHQ6Fb5pGQk4sPsuTkhq5sRurCGk4uLQesCHz2DJXo3S88Bg9EFV33M(oBDR9BHV7aIa7HzYcLwh5H9pLjuJZDH6O7pcS95sOnhQtWLkZdKZTC(xxVP9pynGkj(ucwKZpFzkXP)e)1m3kmnomZpBlhiChbT4UHzx4j)4EHgZeoBb1HVimZbT7HHs4ajucrKHzlA8))tQXaU5cZ8mtW2drPqjosdSYp9hXaFTc4bNimZ(wBcnBTA51ACt7WSxjvQmTN)njiBPyke9gLPyed(EofhMvP(qJCHZMiWdmH1joyOgs4Izknw)6FxOHr85Vi623yablvoaPSqXZ9sCQXNRLOFEtOPG7ryQXx0SkshZ)lRi)mOwQIsOUWQmx9XFZOhEvi54ez6NxpnQYfbO(ygSgtjM5E1HtQv)tQrAkqmhcRl0KZgPeS973o6HmIfSFHOPkr4ciMRAY2zu8Jve(9BU3XKUgTgNQCo0elC6fj9t8NM7mT0tafyfxfbQlNPbns94hD40M4zjXTnIqduAl3Y)2Kg4)mbluxIduM75Jcuefx65vtn582)RmPdrJcaBUhUhFiufTlFGa1HIHnim3Gij(fFO2TNog6S5YiHqePl5h)7TpMbo)1gOQzMWg9uLaOkfRsu(oq7E8amy3J4RF3mNF)o)1EhlwoBsbPmNsXoscNPV4gekLpuBrNl90ilMojJwqlCvpqqy9P4anSfYx9lLzVWV(TXjq6eZUGjeeReBPGRY0guxObQFSl)YfTUwQX8r7d2(ebrTnQIIigJ)DNl)2pZO96bwQfgUGngktJl(UZ80eOJSvHKn8KaRPA7fDp8r(jD4SxnXpNED8qOfXlq3nbDpWsv1Dqc5ydLqhLERY2LOCI(BjWIvfemZLoAr1wmMkXIP8vY1IAIlfn1I7wqfsGpf5GDHkdrIDG1885c5u(n5UXLtlISNGqHkyPkH4Ij9Sce)Pd")

	if loadedData then
		local unData = Compression:StringToTable(loadedData.A)
		self.currentLembas = unData.C or 0
		self.totalLembas = unData.T or 0
		self.ownedBuildings = unData.B or {}
		self.ownedUpgrades = unData.U or {}
	else
		self.currentLembas = 0
		self.totalLembas = 0
		self.ownedBuildings = {}
		self.ownedUpgrades = {}
	end


	self.clickValue = 1
	self.lps = 0
	self.lastClick = 0


	self.lastUpdate = Turbine.Engine.GetGameTime()

	self.ExecuteUpdate = function(delta)
		self.currentLembas = self.currentLembas + self.lps * delta
		self.totalLembas = self.totalLembas + self.lps * delta
		self:UpdateTotal()
		if Turbine.Engine.GetGameTime() - self.lastUpdate  > 0.5 then
			self.lastUpdate = Turbine.Engine.GetGameTime()
			self:SetBuildingAvailability()
		end
	end

	AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)

	self.buildingLabels = {}
	for key, value in ipairs(self.buildings) do
		self.buildingLabels[value.Name] = self:CreateBuildingLabel(self.BuildingListbox:GetWidth(), value, key)
		self.BuildingListbox:AddItem(self.buildingLabels[value.Name])
	end
	self.upgradeLabels = {}
	for buildingID, upgradeList in ipairs(self.upgrades) do
		for upgradeID, upgradeInfo in ipairs(upgradeList) do
			if not self.ownedUpgrades[buildingID] or not self.ownedUpgrades[buildingID][upgradeID] then
				local label =  self:CreateUpgradeLabel(self.UpgradeListbox:GetWidth(), self.buildings[buildingID].Name, upgradeInfo, buildingID, upgradeID)
				table.insert(self.upgradeLabels, label)
				self.UpgradeListbox:AddItem(label)
			end
		end
	end



	for key, value in ipairs(self.ownedBuildings) do
		self:CheckUpgradeAvailability(key)
	end



	self:SetValues()
end

function LembasClickerWindow:ParseNumber(number, digits)
	if number < 1000 and not digits then return math.floor(number) end
    local units = {"", "thousand", "million", "billion", "trillion", "quadrillion", "quintillion", "sextillion", "septillion", "octillion", "nonillion", "decillion", "undecillion"}
    local unitIndex = 1

    while number >= 1000 and unitIndex < #units do
        number = number / 1000
        unitIndex = unitIndex + 1
    end

    return string.format("%." .. tostring(digits or 3) .. "f %s", number, units[unitIndex])
end

function LembasClickerWindow:SetValues()
	self.lps = 0
	self.clickValue = 1

	for key, value in pairs(self.ownedBuildings) do
		local buildingInfo = self.buildings[key]
		if buildingInfo then
			if self.buildingLabels[buildingInfo.Name] then
				local LPS_Multiplier = 1
				local Click_Multiplier = 1
				if self.ownedUpgrades[key] then
					for upgradeID, upgradeValue in pairs(self.ownedUpgrades[key]) do
						if upgradeValue then
							local upgradeInfo = self.upgrades[key][upgradeID]
							LPS_Multiplier = LPS_Multiplier * upgradeInfo.LPS_Multiplier
							Click_Multiplier = Click_Multiplier * upgradeInfo.Click_Multiplier
						end
					end
				end


				self.lps = self.lps + value * buildingInfo["LPSValue"] * LPS_Multiplier
				self.clickValue = self.clickValue + value * buildingInfo["ClickValue"] * Click_Multiplier
				self.buildingLabels[buildingInfo.Name]:changeOwned(value)
			end
		end
	end

	self:LPSUpdate()
end

function LembasClickerWindow:SetBuildingAvailability()
	for key, value in pairs(self.buildingLabels) do
		value:CheckValue()
	end

	for key, value in pairs(self.upgradeLabels) do
		value:CheckValue()
	end
end

function LembasClickerWindow:LembasClick()
	LembasValueLabel(self:ParseNumber(math.floor(self.clickValue), 0))

	self.currentLembas = self.currentLembas + self.clickValue
	self.totalLembas = self.totalLembas + self.clickValue

	self:UpdateTotal()

	self.lastClick = Turbine.Engine.GetGameTime()
end

function LembasClickerWindow:LPSUpdate()
	self.LembasPerSecond:SetText(tostring(self:ParseNumber(self.lps,1)) .. " Lembas per second")
end

function LembasClickerWindow:UpdateTotal()
	self.LembasCountTotal:SetText(tostring(self:ParseNumber(self.currentLembas)) .. " Lembas")
end

function LembasClickerWindow:BuyBuilding(id)
	local buildingInfo = self.buildings[id]

	if buildingInfo then
		if not self.ownedBuildings[id] then
			self.ownedBuildings[id] = 0
		end

		local buildingCost = buildingInfo["BaseCost"] * math.pow(1.15, self.ownedBuildings[id])

		if self.currentLembas >= buildingCost then
			self.currentLembas = self.currentLembas - buildingCost
			self.ownedBuildings[id] = self.ownedBuildings[id] + 1

			self:UpdateTotal()
			self:SetValues()
			self:CheckUpgradeAvailability(id)
		end
	end
end

function LembasClickerWindow:CheckUpgradeAvailability(buildingID) 
	for key, value in pairs(self.upgradeLabels) do
		value:CheckAvailable(buildingID, self.ownedBuildings[buildingID])
	end
end

function LembasClickerWindow:BuyUpgrade(buildingID, upgradeID)
	local buildingInfo = self.buildings[buildingID]
	local upgradeInfo = self.upgrades[buildingID][upgradeID]

	if buildingInfo and upgradeInfo then
		if not self.ownedUpgrades[buildingID] then
			self.ownedUpgrades[buildingID] = {}
		end

		if not self.ownedUpgrades[buildingID][upgradeID] then
			self.ownedUpgrades[buildingID][upgradeID] = false
		end 

		if self.currentLembas >= upgradeInfo.Cost then
			self.currentLembas = self.currentLembas - upgradeInfo.Cost

			self.ownedUpgrades[buildingID][upgradeID] = true

			self:UpdateTotal()
			self:SetValues()

			return true
		end
	end

	return false
end

function LembasClickerWindow:CreateBuildingLabel(width, args, id)
	local background = Turbine.UI.Control()
	background:SetSize(width, 40)
	background:SetBackColor(Turbine.UI.Color.Black)
	background.value = args.BaseCost

	local inside = Turbine.UI.Control()
	inside:SetParent(background)
	inside:SetSize(width - 2 , 40 - 2)
	inside:SetBackColor(Turbine.UI.Color(0.1, 1, 1, 1))
	inside:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

	local iconControl = Turbine.UI.Control()
	iconControl:SetParent(background)
	iconControl:SetSize(32, 32)
	iconControl:SetBackground(args.Icon)
	iconControl:SetPosition(0, 4)
	iconControl:SetBlendMode(Turbine.UI.BlendMode.Overlay)

	local nameLabel = Turbine.UI.Label()
	nameLabel:SetParent(inside)
	nameLabel:SetSize(inside:GetWidth() - 32, inside:GetHeight())
	nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	nameLabel:SetOutlineColor(Turbine.UI.Color.Black)
	nameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	nameLabel:SetForeColor(Turbine.UI.Color.White)
	nameLabel:SetText(args.Name)
	nameLabel:SetMouseVisible(false)
	nameLabel:SetPosition(32, 0)

	local costLabel = Turbine.UI.Label()
	costLabel:SetParent(inside)
	costLabel:SetSize(inside:GetWidth(), inside:GetHeight())
	costLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	costLabel:SetOutlineColor(Turbine.UI.Color.Black)
	costLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
	costLabel:SetForeColor(Turbine.UI.Color.White)
	costLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
	costLabel:SetText(self:ParseNumber(args.BaseCost))
	costLabel:SetMouseVisible(false)

	local ownedLabel = Turbine.UI.Label()
	ownedLabel:SetParent(inside)
	ownedLabel:SetSize(inside:GetWidth(), inside:GetHeight())
	ownedLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	ownedLabel:SetOutlineColor(Turbine.UI.Color.Black)
	ownedLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
	ownedLabel:SetForeColor(Turbine.UI.Color.White)
	ownedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
	ownedLabel:SetText("0")
	ownedLabel:SetMouseVisible(false)

	background.changeOwned = function(sender, newOwned)
		ownedLabel:SetText(tostring(newOwned))

		background.value = math.ceil(args.BaseCost * math.pow(1.15, newOwned))
		costLabel:SetText(tostring(self:ParseNumber(math.ceil(args.BaseCost * math.pow(1.15, newOwned)))))

		if self.currentLembas >= background.value then
			costLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
		else
			costLabel:SetForeColor(Turbine.UI.Color.DarkRed)
		end

		background:SetVisible(args.BaseCost <= self.totalLembas)
	end

	inside.MouseClick = function()
		self:BuyBuilding(id)
	end

	background.CheckValue = function(sender, value)
		if self.currentLembas >= background.value then
			costLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
		else
			costLabel:SetForeColor(Turbine.UI.Color.DarkRed)
		end

		background:SetVisible(args.BaseCost <= self.totalLembas)
	end

	if self.currentLembas >= background.value then
		costLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
	else
		costLabel:SetForeColor(Turbine.UI.Color.DarkRed)
	end

	background:SetVisible(args.BaseCost <= self.totalLembas)

	return background
end

function LembasClickerWindow:Unload()
	SaveTable(Turbine.DataScope.Account, "PrimeLembasClickers", {["A"] = Compression:TableToString({["B"] = self.ownedBuildings, ["U"] = self.ownedUpgrades, ["T"] = self.totalLembas, ["C"] = self.currentLembas})})
end

function LembasClickerWindow:CreateUpgradeLabel(width, buildingName, args, id, uID)
	local background = Turbine.UI.Control()
	background:SetSize(width, 40)
	background:SetBackColor(Turbine.UI.Color.Black)
	background.value = args.Cost
	background:SetVisible(false)
	background:SetHeight(0)

	local inside = Turbine.UI.Control()
	inside:SetParent(background)
	inside:SetSize(width - 2 , 40 - 2)
	inside:SetBackColor(Turbine.UI.Color(0.1, 1, 1, 1))
	inside:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

	local nameLabel = Turbine.UI.Label()
	nameLabel:SetParent(inside)
	nameLabel:SetSize(inside:GetWidth(), inside:GetHeight())
	nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	nameLabel:SetOutlineColor(Turbine.UI.Color.Black)
	nameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	nameLabel:SetForeColor(Turbine.UI.Color.White)
	nameLabel:SetText(tostring(buildingName) .. ": " .. args.Name)
	nameLabel:SetMouseVisible(false)

	local upgrdeInfoLabel = Turbine.UI.Label()
	upgrdeInfoLabel:SetParent(inside)
	upgrdeInfoLabel:SetSize(inside:GetWidth(), inside:GetHeight())
	upgrdeInfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	upgrdeInfoLabel:SetOutlineColor(Turbine.UI.Color.Black)
	upgrdeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold14)
	upgrdeInfoLabel:SetForeColor(Turbine.UI.Color.White)
	upgrdeInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft)
	upgrdeInfoLabel:SetText("LPS multiplier: " .. tostring(args.LPS_Multiplier) .. "x Click multiplier: " .. tostring(args.Click_Multiplier) .. "x")
	upgrdeInfoLabel:SetMouseVisible(false)

	local costLabel = Turbine.UI.Label()
	costLabel:SetParent(inside)
	costLabel:SetSize(inside:GetWidth(), inside:GetHeight())
	costLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	costLabel:SetOutlineColor(Turbine.UI.Color.Black)
	costLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	costLabel:SetForeColor(Turbine.UI.Color.White)
	costLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
	costLabel:SetText(self:ParseNumber(args.Cost, 0))
	costLabel:SetMouseVisible(false)

	inside.MouseClick = function()
		if self:IsVisible() then
			if self:BuyUpgrade(id, uID) then
				background:SetVisible(false)
				background:SetHeight(0)
			end
		end
	end

	background.CheckAvailable = function(sender, buildingID, amount)
		if id == buildingID and (not self.ownedUpgrades[buildingID] or not self.ownedUpgrades[buildingID][uID]) then
			background:SetVisible(amount >= args.Requirement)
			if background:IsVisible() then
				background:SetHeight(40)
			end
		end
	end

	background.CheckValue = function(sender, value)
		if self.currentLembas >= background.value then
			costLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
		else
			costLabel:SetForeColor(Turbine.UI.Color.DarkRed)
		end
	end

	if self.currentLembas >= background.value then
		costLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
	else
		costLabel:SetForeColor(Turbine.UI.Color.DarkRed)
	end

	return background
end

LembasValueLabel = class(Turbine.UI.Window)
function LembasValueLabel:Constructor(value)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(100, 20)
	local x, y = self:GetMousePosition()
	x = x - self:GetWidth() / 2
	y = y - 20
    self:SetPosition(x, y)
    self:SetWantsKeyEvents(false)
	self:SetMouseVisible(false)
	self:SetWantsUpdates(true)
    self:SetVisible(true)

	self.icon = Turbine.UI.Window()
	self.icon:SetParent(self)
	self.icon:SetVisible(true)
	self.icon:SetBackground(0x410FC45B)
	self.icon:SetMouseVisible(false)
	self.icon:SetStretchMode(2)
	self.icon:SetStretchMode(1)
	self.icon:SetSize(self:GetHeight(), self:GetHeight())

	self.label = Turbine.UI.Label()
	self.label:SetParent(self)
	self.label:SetMouseVisible(false)
	self.label:SetPosition(self.icon:GetWidth(), 0)
	self.label:SetSize(self:GetWidth() - self.icon:GetWidth(), self:GetHeight())
	self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label:SetOutlineColor(Turbine.UI.Color.Black)
	self.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
	self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.label:SetForeColor(Turbine.UI.Color.White)
	self.label:SetText("+" .. tostring(value))

	self.timer = 2

	self.ExecuteUpdate = function(delta)
		self:SetTop(self:GetTop() - 0.1)
		self.timer = self.timer - delta
		self.icon:SetOpacity(self.timer / 3)
		self:SetOpacity( self.timer / 3)

		if self.timer < 0 then
			RemoveCallback(Updater, "ExecuteUpdate", self.callback)
			self:SetParent(nil)
			self:SetVisible(false)
		end
	end

	self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
end