GroupVitalsHandler = class()
function GroupVitalsHandler:Constructor()

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.vitalProfiles = LoadTable(Turbine.DataScope.Account, "PrimeGroupVitals") or
    {
        ["Profiles"] = {
            ["Base_Profile"] = self:GetBaseProfile()
        },
        ["Active_Profile"] = {}
    }

    if not self.vitalProfiles["Active_Profile"][self.player:GetName()] and self.vitalProfiles["Profiles"]["Base_Profile"] then
        self.vitalProfiles["Active_Profile"][self.player:GetName()] = "Base_Profile"
    end 


    self.frameHandler = GroupFrameHandler(self)
end

function GroupVitalsHandler:Unload()
    SaveTable(Turbine.DataScope.Account, "PrimeGroupVitals", self.vitalProfiles)
end

function GroupVitalsHandler:ToggleMove()
    self.frameHandler:ToggleMove()
end

function GroupVitalsHandler:FireEvent(source, value, args)
    self.frameHandler:FireEvent(source, value, args)
end

function GroupVitalsHandler:GetActiveProfileName()
    return tostring(self.vitalProfiles["Active_Profile"][self.player:GetName()])
end

function GroupVitalsHandler:GetActiveProfile()
    return self.vitalProfiles["Profiles"][self:GetActiveProfileName()] or {}
end

function GroupVitalsHandler:SetTestMode(value)
    self.frameHandler:SetTestMode(value)
end

function GroupVitalsHandler:AddNewProfile(name)

    if self.vitalProfiles["Profiles"][name] then return false end

    self.vitalProfiles["Profiles"][name] = self:GetBaseProfile()
    self:SetActiveProfile(name)
    return true
end

function GroupVitalsHandler:GetProfileList()
    return self.vitalProfiles["Profiles"]
end

function GroupVitalsHandler:SetActiveProfile(name)
    if self.vitalProfiles["Profiles"][name] then
        self.vitalProfiles["Active_Profile"][self.player:GetName()] = name

        self.frameHandler:ReloadFrames(self.vitalProfiles["Profiles"][name])
        -- DO
    end
end

function GroupVitalsHandler:ImportProfile(name, profile)
    if self.vitalProfiles["Profiles"][name] then
        return false
    else
        self.vitalProfiles["Profiles"][name] = profile
        self:SetActiveProfile(name)
        return true
    end
end

function GroupVitalsHandler:GetProfile(name)
    return self.vitalProfiles["Profiles"][name] or {}
end

function GroupVitalsHandler:ChangeValue(name, group, field, value)
    if self.vitalProfiles["Profiles"][name] and self.vitalProfiles["Profiles"][name][group] and self.vitalProfiles["Profiles"][name][group][field] ~= nil then
        self.vitalProfiles["Profiles"][name][group][field] = value
        self:UpdateFrames()
    end
end

function GroupVitalsHandler:ChangeListValue(name, group, field, tableField, value)
    if self.vitalProfiles["Profiles"][name] and self.vitalProfiles["Profiles"][name][group] and self.vitalProfiles["Profiles"][name][group][field] ~= nil then
        self.vitalProfiles["Profiles"][name][group][field][tableField] = value
        self:UpdateFrames()
    end
end

function GroupVitalsHandler:UpdateFrames()
    self.frameHandler:ReloadFrames(self:GetActiveProfile())
end

function GroupVitalsHandler:GetBaseProfile()
    return {
        ["Group_Frame"] = {
            ["Frames_Per_Column"] = 6,
            ["Orientation"] = "Vertical",
            ["Reversefill"] = false,
            ["FlippedLayout"] = false,
            ["BorderSize"] = 2,
            ["BoxOffset"] = 0,
            ["Disable_Base_Frame"] = true,
            ["X"] = 400,
            ["Y"] = 100,
        },

        ["Player_Frame"] = {
            ["Highlight_Size"] = 2,
            ["Highlight_Colour"] =  {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
        },

        ["Colours"] = {
            ["BorderColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 0},
            ["UseClassColours"] = true,
        },

        ["Icon"] = {
            ["IconX"] = 3,
            ["IconY"] = 3,
            ["ShowIcon"] = true,
            ["Leader_X"] = 184,
            ["Leader_Y"] = 4,
        },

        ["Name"] = {
            ["NamePositionX"] = 25,
            ["NamePositionY"] = 5,
            ["NameSizeX"] = 200,
            ["NameSizeY"] = 20,
            ["NameColour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["NameFont"] = "TrajanProBold16",
            ["NameLength"] = 6,
            ["NameStringOutline"] = true,
            ["NameStringOutlineColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 0},
        },

        ["Health"] = {
            ["HealthStringPositionX"] = 5,
            ["HealthStringPositionY"] = 30,
            ["HealthStringSizeX"] = 200,
            ["HealthStringSizeY"] = 20,
            ["HealthStringColour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["HealthStringFont"] = "BookAntiquaBold18",
            ["HealthStringShowCurrent"] = true,
            ["HealthStringShowTotal"] = true,
            ["HealthStringPercentage"] = true,
            ["HealthStringAlignment"] = "MiddleCenter",
            ["HealthWidth"] = 200,
            ["HealthHeight"] = 70,
            ["HealthBackgroundColour"] = {[1] = 1, [2] = 0, [3] = 0.5, [4] = 0},
            ["HealthColour"] = {[1] = 1, [2] = 0, [3] = 1, [4] = 0},
            ["TemporaryHealthColour"] = {[1] = 1, [2] = 0.4, [3] = 0, [4] = 0.4},
            ["HealthCurrentString"] = "%s",
            ["HealthPercentageString"] = " (%s%%)",
            ["HealthTotalString"] = "/%s",
            ["HealthTemporary"] = true,
            ["HealthTemporaryString"] = " [%s]",
            ["HealthStringOutlineColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 0},
            ["HealthStringOutline"] = true,
        },

        ["Power"] = {
            ["PowerStringPositionX"] = 0,
            ["PowerStringPositionY"] = 70,
            ["PowerStringSizeX"] = 200,
            ["PowerStringSizeY"] = 20,
            ["PowerStringColour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["PowerStringFont"] = "BookAntiquaBold18",
            ["PowerStringShowCurrent"] = false,
            ["PowerStringShowTotal"] = false,
            ["PowerStringPercentage"] = true,
            ["PowerStringAlignment"] = "MiddleCenter",
            ["PowerHeight"] = 15,
            ["PowerBackgroundColour"] = {[1] = 0.5, [2] = 0, [3] = 0, [4] = 1},
            ["PowerColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 1},
            ["PowerCurrentString"] = "%s",
            ["PowerPercentageString"] = "%s%%",
            ["PowerTotalString"] = "/%s",
            ["PowerTemporary"] = true,
            ["PowerTemporaryString"] = " [%s]",
            ["PowerStringOutlineColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 0},
            ["PowerStringOutline"] = true,
        },

        ["EffectBox"] = {
            ["X"] = 1,
            ["Y"] = 50,
            ["Width"] = 200,
            ["Height"] = 22,
            ["Orientation"] = "Horizontal",
            ["Reversefill"] = false,
            ["FlippedLayout"] = false,
            ["ItemSize"] = 22,

            ["Effect_Scale"] = 1,
            ["Spacing"] = 1,
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["Show_Duration"] = true,
            ["Effect_Duration_Font"] = "Verdana12",
            ["Effect_Duration_TextAlignment"] = "BottomRight",
            ["Visibility_Threshold"] = 10,
            ["Show_Stack"] = true,
            ["Effect_Stack_Font"] = "Verdana12",
            ["Effect_Stack_TextAlignment"] = "TopLeft",
        },

        ["Effect_Conditions"] = {
            ["Generic_White_List"] = {
                --["Water-lore"] = { ["Applications"] = 2, ["Match_Icon"] = true, ["Icon"] = 1091768135 },
                ["Hunker Down"] = { ["Applications"] = 1 },
                ["Stout-shield"] = { ["Applications"] = 1 },
                ["Shield of the Dúnedain"] = { ["Applications"] = 1 },
            },
        },

        ["Effect_Conditions_Class"] = {
            ["BlackArrow_White_List"] = {},
            ["Beorning_White_List"] = {
                ["Thickened Hide"] = { ["Applications"] = 1 },
                ["Hurricane"] = { ["Applications"] = 1 },
                ["Thorned Armour Damage Reflection"] = { ["Applications"] = 1 },
                ["Counter"] = { ["Applications"] = 1 },
            },
            ["Brawler_White_List"] = {
                ["Weather Blows"] = { ["Applications"] = 1 },
            },
            ["Burglar_White_List"] = {},
            ["Captain_White_List"] = {
                ["Last Stand"] = { ["Applications"] = 1 },
                ["At the Fore"] = { ["Applications"] = 1, ["Match_Icon"] = true, ["Icon"] = 1092812518 },
            },
            ["Champion_White_List"] = {
                ["Adamant"] = { ["Applications"] = 1 },
            },
            ["Chicken_White_List"] = {},
            ["Defiler_White_List"] = {},
            ["Guardian_White_List"] = {
                ["Warrior's Heart"] = { ["Applications"] = 1, ["Match_Icon"] = true, ["Icon"] = 1090541182 },
                ["Guardian's Pledge"] = { ["Applications"] = 1 },
                ["Juggernaut"] = { ["Applications"] = 1 },
            },
            ["Hunter_White_List"] = {},
            ["LoreMaster_White_List"] = {},
            ["Minstrel_White_List"] = {},
            ["Ranger_White_List"] = {},
            ["Reaver_White_List"] = {},
            ["RuneKeeper_White_List"] = {},
            ["Stalker_White_List"] = {},
            ["Troll_White_List"] = {},
            ["Warden_White_List"] = {
                ["Determined"] = { ["Applications"] = 1 },
            },
            ["WarLeader_White_List"] = {},
            ["Weaver_White_List"] = {},
        },

        ["Box_Timers"] = {
            ["Top_Left_Box_Colour"] = {[1] = 1, [2] = 8/255, [3] = 144/255, [4] = 1},
            ["Top_Right_Box_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["Bottom_Right_Box_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 0},
            ["Bottom_Left_Box_Colour"] = {[1] = 1, [2] = 1, [3] = 0, [4] = 187/255},
        }
    }
end
