GroupVitalsOptionsWindow = class(Turbine.UI.Control)
function GroupVitalsOptionsWindow:Constructor(parent)
    self.width = Settings.LOWidth
    local height = 550
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(self.width,height)
    self:SetPosition(0, 0)
    self:SetVisible(false)

    --self:SetBackColor(Turbine.UI.Color.Red)

    self.textAlignments = {
        ["BottomCenter"] = Turbine.UI.ContentAlignment.BottomCenter,
        ["BottomLeft"] = Turbine.UI.ContentAlignment.BottomLeft,
        ["BottomRight"]	= Turbine.UI.ContentAlignment.BottomRight,
        ["MiddleCenter"] = Turbine.UI.ContentAlignment.MiddleCenter,
        ["MiddleLeft"] = Turbine.UI.ContentAlignment.MiddleLeft,
        ["MiddleRight"] = Turbine.UI.ContentAlignment.MiddleRight,
        ["TopCenter"] = Turbine.UI.ContentAlignment.TopCenter,
        ["TopLeft"] = Turbine.UI.ContentAlignment.TopLeft,
        ["TopRight"] = Turbine.UI.ContentAlignment.TopRight,
    }

    self.listboxOrientations = {
        ["Horizontal"] = true,
        ["Vertical"] = true,
    }

    self.infoWindow = PrimeUITools.PrimeUIOptions.InfoWindow()

    self.listboxCategories = {
        ["Generic_White_List"] = true,
        ["BlackArrow_White_List"] = true,
        ["Beorning_White_List"] = true,
        ["Brawler_White_List"] = true,
        ["Burglar_White_List"] = true,
        ["Captain_White_List"] = true,
        ["Champion_White_List"] = true,
        ["Chicken_White_List"] = true,
        ["Defiler_White_List"] = true,
        ["Guardian_White_List"] = true,
        ["Hunter_White_List"] = true,
        ["LoreMaster_White_List"] = true,
        ["Minstrel_White_List"] = true,
        ["Ranger_White_List"] = true,
        ["Reaver_White_List"] = true,
        ["RuneKeeper_White_List"] = true,
        ["Stalker_White_List"] = true,
        ["Troll_White_List"] = true,
        ["Warden_White_List"] = true,
        ["WarLeader_White_List"] = true,
        ["Weaver_White_List"] = true,
    }

    self.activateCheckbox = Turbine.UI.Lotro.CheckBox()
    self.activateCheckbox:SetParent(self)
    self.activateCheckbox:SetSize(200, 20)
    self.activateCheckbox:SetText("Enable Group Vitals")
    self.activateCheckbox:SetChecked(Settings.GroupVitalsEnabled)
    self.activateCheckbox.CheckedChanged = function()
        Settings.GroupVitalsEnabled = self.activateCheckbox:IsChecked()
    end

    self.testCheckbox = Turbine.UI.Lotro.CheckBox()
    self.testCheckbox:SetParent(self)
    self.testCheckbox:SetSize(200, 20)
    self.testCheckbox:SetPosition(0, 20)
    self.testCheckbox:SetText("Enable Test Mode")
    self.testCheckbox:SetChecked(false)
    self.testCheckbox.CheckedChanged = function()
       GroupVitalsHandlerObject:SetTestMode(self.testCheckbox:IsChecked())
    end

    self.profileMenu = Turbine.UI.ContextMenu()
    self.profileItems = self.profileMenu:GetItems()

    self.activeProfileButton = Turbine.UI.Lotro.Button()
    self.activeProfileButton:SetParent(self)
    self.activeProfileButton:SetPosition(200, 0)
    self.activeProfileButton:SetText(string.format("Active Profile: %s", GroupVitalsHandlerObject:GetActiveProfileName()))
    self.activeProfileButton:SetSize(250, 20)

    self.moveButton = Turbine.UI.Lotro.Button()
    self.moveButton:SetParent(self)
    self.moveButton:SetPosition(200, 20)
    self.moveButton:SetText("Move")
    self.moveButton:SetSize(250, 20)

    self.moveButton.Click = function()
        GroupVitalsHandlerObject:ToggleMove()
    end

    self.importProfileButton = Turbine.UI.Lotro.Button()
    self.importProfileButton:SetParent(self)
    self.importProfileButton:SetPosition(500, 20)
    self.importProfileButton:SetText("Import Profile")
    self.importProfileButton:SetSize(125, 20)
    self.importProfileButton.Click = function()
        if not self.IOwindow then self.IOwindow = GroupVitalsIOWindow() end
        self.IOwindow:View()
    end

    self.exportProfileButton = Turbine.UI.Lotro.Button()
    self.exportProfileButton:SetParent(self)
    self.exportProfileButton:SetPosition(625, 20)
    self.exportProfileButton:SetText("Export Profile")
    self.exportProfileButton:SetSize(125, 20)
    self.exportProfileButton.Click = function()
        if not self.IOwindow then self.IOwindow = GroupVitalsIOWindow() end
        self.IOwindow:View(GroupVitalsHandlerObject:GetActiveProfile(), GroupVitalsHandlerObject:GetActiveProfileName())
    end


    self.newProfileTextBox = Turbine.UI.Lotro.TextBox()
    self.newProfileTextBox:SetParent(self)
    self.newProfileTextBox:SetSize(200, 20)
    self.newProfileTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.newProfileTextBox:SetText("Profile Name")
    self.newProfileTextBox:SetPosition(500, 0)

    self.addNewProfileButton = Turbine.UI.Lotro.Button()
    self.addNewProfileButton:SetParent(self)
    self.addNewProfileButton:SetPosition(700, 0)
    self.addNewProfileButton:SetText("Add")
    self.addNewProfileButton:SetSize(50, 20)
    self.addNewProfileButton.Click = function()
        GroupVitalsHandlerObject:AddNewProfile(tostring(self.newProfileTextBox:GetText()))
        self.activeProfileButton:SetText(string.format("Active Profile: %s", GroupVitalsHandlerObject:GetActiveProfileName()))
        GroupVitalsHandlerObject:SetActiveProfile(GroupVitalsHandlerObject:GetActiveProfileName())
        self:CreateOptions(GroupVitalsHandlerObject:GetProfile(GroupVitalsHandlerObject:GetActiveProfileName()))
    end

    self.profileListbox = Turbine.UI.TreeView()
    self.profileListbox:SetParent(self)
    self.profileListbox:SetPosition(0, 40)
    self.profileListbox:SetSize(self.width - 10, height - 40)
    --self.profileListbox:SetBackColor(Turbine.UI.Color.Gold)

    self.treeNodes = self.profileListbox:GetNodes()

    self.profileListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.profileListBoxScrollbar:SetParent(self)
    self.profileListBoxScrollbar:SetPosition(self.width - 10, 40)
    self.profileListBoxScrollbar:SetSize(10, height - 40)
    self.profileListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.profileListbox:SetVerticalScrollBar(self.profileListBoxScrollbar)

    self.activeProfileButton.Click = function ()
        self.profileItems:Clear()
        
        for key, _ in pairs(GroupVitalsHandlerObject:GetProfileList()) do
            local menuItem = Turbine.UI.MenuItem(key)

            menuItem.Click = function()
                self.activeProfileButton:SetText(string.format("Active Profile: %s", key))
                GroupVitalsHandlerObject:SetActiveProfile(key)
                self:CreateOptions(GroupVitalsHandlerObject:GetProfile(GroupVitalsHandlerObject:GetActiveProfileName()))
            end

            self.profileItems:Add(menuItem)
        end

        self.profileMenu:ShowMenu()
    end

    self:CreateOptions(GroupVitalsHandlerObject:GetProfile(GroupVitalsHandlerObject:GetActiveProfileName()))
end

function GroupVitalsOptionsWindow:CreateOptions(profileData)
    self.treeNodes:Clear()

    local width = self.profileListbox:GetWidth()

    for key, value in spairs(profileData, function(t, a, b) return a < b end) do
        local categoryNode = self:OptionLabel(self.profileListbox:GetWidth(), key)
        local categoryNodeChildren = categoryNode:GetChildNodes()
        for key2, value2 in spairs(value, function(t, a, b) return a < b end) do
            

            if string.find(key2, "Colour") and type(value2) == "table" then
                categoryNodeChildren:Add(self:ColourInput(width, key2, value2, (function(newColour, index)
                    GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, newColour)
                end)))
            elseif string.find(key2, "Font") then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.FontInput(width, key2, value2, (function(newFont)
                    GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, newFont)
                end)))
            elseif IsNumber(value2) then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.NumericalInput(width, key2, value2, (function(text) 
                    local number = tonumber(text)
                    if number then
                        GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, number)
                    end
                end)))
            elseif self.listboxCategories[key2] then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.CreateTriggerListBox(width, key2, value2, "GroupVitals", (function(effectName, newState)
                    GroupVitalsHandlerObject:ChangeListValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, effectName, newState)
                end), self))
            elseif string.find(key2, "Orientation") then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.AlignmentInput(width, key2, value2, self.listboxOrientations, (function(alignment)
                    GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, alignment)
                end)))
            elseif string.find(key2, "Alignment") then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.AlignmentInput(width, key2, value2, self.textAlignments, (function(alignment)
                    GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, alignment)
                end)))
            elseif (value2 == true or value2 == false) then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.BoolInput(width, key2, value2, (function(bool) 
                    GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, bool)
                end)))
            elseif type(value2) == "string" then
                categoryNodeChildren:Add(PrimeUITools.PrimeUIOptions.StringInput(width, key2, value2, key2 == "Text", (function(text) 
                    if text then
                        GroupVitalsHandlerObject:ChangeValue(GroupVitalsHandlerObject:GetActiveProfileName(), key, key2, text)
                    end
                end)))
            else
                categoryNodeChildren:Add(self:OptionLabel(self.profileListbox:GetWidth(), key2))
            end
        end
        self.treeNodes:Add(categoryNode)
    end

    --self.profileListbox:ExpandAll()
end

function GroupVitalsOptionsWindow:OptionLabel(width, text)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 24)

    valuebar.border = Turbine.UI.Control()
    valuebar.border:SetParent(valuebar)
    valuebar.border:SetSize(width, 24)
    valuebar.border:SetMouseVisible(false)
    valuebar.border:SetBackColor(Turbine.UI.Color(0, 0, 0))

    valuebar.label = Turbine.UI.Label()
    valuebar.label:SetParent(valuebar)
    valuebar.label:SetSize(width - 4, 24 - 4)
    valuebar.label:SetPosition(2, 2)
    valuebar.label:SetMouseVisible(false)
    valuebar.label:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.label:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
    valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold25)
    valuebar.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    valuebar.label:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    valuebar.label:SetText(text)

    return valuebar
end

function GroupVitalsOptionsWindow:ColourInput(width, text, currentValue, func)

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 130)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

    valuebar.Unload = function()
        local controlList = valuebar:GetControls()
        for i = 1, controlList:GetCount() do
            local item = controlList:Get(1)
            if item.Unload then
                item:Unload()
            end
            controlList:RemoveAt(1)
        end
    end

    valuebar.SizeChanged = function()
        local controlList = valuebar:GetControls()
        for i = 1, controlList:GetCount() do
            local item = controlList:Get(1)
            if item.SetWidth then
                item:SetWidth(valuebar:GetWidth())
            end
        end
    end

    if currentValue then
        if type(currentValue[1]) == "table" then
            for key, value in pairs(currentValue) do
                PrimeUITools.PrimeUIOptions.SingleColourOptions(valuebar, width, string.format("%s [%d]", text, key), value, func, key)
                valuebar:SetSize(width, 130 * key)
            end
            return valuebar
        else
            PrimeUITools.PrimeUIOptions.SingleColourOptions(valuebar, width, text, currentValue, func)
            return valuebar
        end
    end

    return valuebar
end

function GroupVitalsOptionsWindow:GetIconWindow()
    if not(self.iconWindow) then self.iconWindow = ClassSpecificTools.IconOverview() end

    return self.iconWindow
end


GroupVitalsIOWindow = class(Turbine.UI.Lotro.Window)
function GroupVitalsIOWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(800, 800)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("GroupVitals IO")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(780, 720)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    --self.TextBox:SetMouseVisible(true)
    self.TextBox:SetPosition(190, 15)
    self.TextBox:SetPosition(10, 40)

    self.SelectButton = Turbine.UI.Lotro.Button()
	self.SelectButton:SetParent(self)
	self.SelectButton:SetSize(100, 20)
	self.SelectButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.SelectButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.SelectButton:SetText("Select All")

    self.SelectButton.Click = function()
        self.TextBox:Focus()
        self.TextBox:SelectAll()
    end

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.ImportButton:SetText("Import")

    self.options = options

    self.ImportButton.Click = function()
        local text = self.TextBox:GetText()
        local key, compressed, _ = string.match(text, "<(.*)>%((.*)%)<(.*)>$")
        local result, table
        table = Compression:StringToTable(compressed)
        self.TextBox:SetText(table)
        if table then result = true end

        if result and key == "PrimeGroupVitals" then
            if GroupVitalsHandlerObject:ImportProfile(table.Name, table.Profile) then
                ChatOutput(string.format("Correctly imported Group Vitals profile %s", table.Name))
                self:SetVisible(false)
            else
                ThrowException("Failed to import profile, it alreayd exists or data is incorrect")
            end
        elseif result and (key == "PrimeUI" or  key == "PrimeUIElement") then
            ThrowException("Failed to add PrimeUI string to the group vitals page! What were you thinking?")
        else
            ThrowException("Failed to add Group Vitals: Incorrect string!")
        end
    end
end

function GroupVitalsIOWindow:View(data, name)
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
    if data then
        self.TextBox:SetText(string.format("<PrimeGroupVitals>(%s)<PrimeGroupVitals>", Compression:TableToString({["Profile"] = data, ["Name"] = name })))
        self.ImportButton:SetVisible(false)
        self.SelectButton:SetVisible(true)
    else
        self.ImportButton:SetVisible(true)
        self.SelectButton:SetVisible(false)
    end
end