PlayerWindow = class( Turbine.UI.Control)
function PlayerWindow:Constructor(player, settings, testMode, leader)
    Turbine.UI.Control.Constructor(self)

    self.settings = settings
    self.player = player

    self:SetSize(
        self.settings.Health.HealthWidth + 2 * self.settings.Group_Frame.BorderSize + self.settings.Group_Frame.BoxOffset, 
        self.settings.Health.HealthHeight + self.settings.Power.PowerHeight + 2 * self.settings.Group_Frame.BorderSize + self.settings.Group_Frame.BoxOffset)
    --self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.backgroundControl = Turbine.UI.Control()
    self.backgroundControl:SetParent(self)
    --self.backgroundControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	--self.backgroundControl:SetBackColor(Turbine.UI.Color.Black)
	self.backgroundControl:SetSize(
        self.settings.Health.HealthWidth + 2 * self.settings.Group_Frame.BorderSize, 
        self.settings.Health.HealthHeight + self.settings.Power.PowerHeight + 2 * self.settings.Group_Frame.BorderSize)
    self.backgroundControl:SetMouseVisible(false)
    self.backgroundControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Colours.BorderColour))

    self.healthBackgroundControl = Turbine.UI.Control()
    self.healthBackgroundControl:SetParent(self)
	self.healthBackgroundControl:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize)
	self.healthBackgroundControl:SetSize(self.settings.Health.HealthWidth, self.settings.Health.HealthHeight)	
    self.healthBackgroundControl:SetMouseVisible(false)
    self.healthBackgroundControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    if self.settings.Colours.UseClassColours then
        local backgroundColour = ClassColoursTableForm[self.player:GetClass()] or {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0}

        self.healthBackgroundControl:SetBackColor(Turbine.UI.Color(0.5, backgroundColour[2], backgroundColour[3], backgroundColour[4]))
    else
        self.healthBackgroundControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Health.HealthBackgroundColour))
    end

    self.healthControl = Turbine.UI.Control()
    self.healthControl:SetParent(self)
	self.healthControl:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize)
	self.healthControl:SetSize(self.settings.Health.HealthWidth / 2, self.settings.Health.HealthHeight)	
    self.healthControl:SetMouseVisible(false)
    self.healthControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    if self.settings.Colours.UseClassColours then
        self.healthControl:SetBackColor(self:ColourTupleToTurbineColour(ClassColoursTableForm[self.player:GetClass()]))
    else
        self.healthControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Health.HealthColour))
    end

    self.temporaryHealthControl = Turbine.UI.Control()
    self.temporaryHealthControl:SetParent(self)
	self.temporaryHealthControl:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize)
	self.temporaryHealthControl:SetSize(self.settings.Health.HealthWidth / 3, self.settings.Health.HealthHeight)	
    self.temporaryHealthControl:SetMouseVisible(false)
    self.temporaryHealthControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.temporaryHealthControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Health.TemporaryHealthColour))

    self.powerBackgroundControl = Turbine.UI.Control()
    self.powerBackgroundControl:SetParent(self)
	self.powerBackgroundControl:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize + self.settings.Health.HealthHeight)
	self.powerBackgroundControl:SetSize(self.settings.Health.HealthWidth, self.settings.Power.PowerHeight)	
    self.powerBackgroundControl:SetMouseVisible(false)
    self.powerBackgroundControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.powerBackgroundControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Power.PowerBackgroundColour))
    self.powerBackgroundControl:SetVisible(self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning)

    self.powerControl = Turbine.UI.Control()
    self.powerControl:SetParent(self)
	self.powerControl:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize + self.settings.Health.HealthHeight)
	self.powerControl:SetSize(self.settings.Health.HealthWidth / 2, self.settings.Power.PowerHeight)	
    self.powerControl:SetMouseVisible(false)
    self.powerControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.powerControl:SetBackColor(self:ColourTupleToTurbineColour(self.settings.Power.PowerColour))
    self.powerControl:SetVisible(self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning)

    self.classControl = Turbine.UI.Control()
    self.classControl:SetParent(self)
    self.classControl:SetBlendMode(Turbine.UI.BlendMode.Overlay )
	self.classControl:SetPosition(self.settings.Icon.IconX, self.settings.Icon.IconY)
	self.classControl:SetSize(20, 20)	
    self.classControl:SetMouseVisible(false)
    self.classControl:SetVisible(self.settings.Icon.ShowIcon)
    self.classControl:SetBackground(ClassIconTable[player:GetClass()])

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetParent(self)
	self.nameLabel:SetPosition(self.settings.Name.NamePositionX, self.settings.Name.NamePositionY)
	self.nameLabel:SetSize(self.settings.Name.NameSizeX, self.settings.Name.NameSizeY)	
    self.nameLabel:SetMouseVisible(false)
    self.nameLabel:SetForeColor(self:ColourTupleToTurbineColour(self.settings.Name.NameColour))
    self.nameLabel:SetFont(self:FontToFont(self.settings.Name.NameFont))
    if self.settings.Name.NameStringOutline then
        self.nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.nameLabel:SetOutlineColor(self:ColourTupleToTurbineColour(self.settings.Name.NameStringOutlineColour))
    end
    self.nameLabel:SetText(string.sub(self.player:GetName(), 1, self.settings.Name.NameLength))

    self.healthLabel = Turbine.UI.Label()
    self.healthLabel:SetParent(self)
	self.healthLabel:SetPosition(self.settings.Health.HealthStringPositionX, self.settings.Health.HealthStringPositionY)
	self.healthLabel:SetSize(self.settings.Health.HealthStringSizeX, self.settings.Health.HealthStringSizeY)	
    self.healthLabel:SetMouseVisible(false)
    self.healthLabel:SetMultiline(false)
    if self.settings.Health.HealthStringOutline then
        self.healthLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.healthLabel:SetOutlineColor(self:ColourTupleToTurbineColour(self.settings.Health.HealthStringOutlineColour))
    end
    self.healthLabel:SetForeColor(self:ColourTupleToTurbineColour(self.settings.Health.HealthStringColour))
    self.healthLabel:SetFont(self:FontToFont(self.settings.Health.HealthStringFont))
    self.healthLabel:SetTextAlignment(Turbine.UI.ContentAlignment[self.settings.Health.HealthStringAlignment])
    self.healthLabel:SetMarkupEnabled(true)
    self:SetHealthText()

    self.powerLabel = Turbine.UI.Label()
    self.powerLabel:SetParent(self)
	self.powerLabel:SetPosition(self.settings.Power.PowerStringPositionX, self.settings.Power.PowerStringPositionY)
	self.powerLabel:SetSize(self.settings.Power.PowerStringSizeX, self.settings.Power.PowerStringSizeY)	
    self.powerLabel:SetMouseVisible(false)
    self.powerLabel:SetMultiline(false)
    if self.settings.Power.PowerStringOutline then
        self.powerLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.powerLabel:SetOutlineColor(self:ColourTupleToTurbineColour(self.settings.Power.PowerStringOutlineColour))
    end
    self.powerLabel:SetForeColor(self:ColourTupleToTurbineColour(self.settings.Power.PowerStringColour))
    self.powerLabel:SetFont(self:FontToFont(self.settings.Power.PowerStringFont))
    self.powerLabel:SetTextAlignment(Turbine.UI.ContentAlignment[self.settings.Power.PowerStringAlignment])
    self.powerLabel:SetMarkupEnabled(true)
    self.powerLabel:SetVisible(self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning)
    self:SetPowerText()

    self.clickControl = Turbine.UI.Lotro.EntityControl()
    self.clickControl:SetParent(self)
    self.clickControl:SetVisible(true)
    self.clickControl:SetSize(self.settings.Health.HealthWidth + 2 * self.settings.Group_Frame.BorderSize, 
    self.settings.Health.HealthHeight + self.settings.Power.PowerHeight + 2 * self.settings.Group_Frame.BorderSize)
    self.clickControl:SetEntity(self.player)

    -- 0x410E3F4A checkmark
    -- 0x410D79FE undecided
    -- 0x410D79FF ready
    -- 0x410D7A00 not ready

    self.iconTable = {}

    self.checkmarkIcon = Turbine.UI.Control()
    self.checkmarkIcon:SetParent(self)
    self.checkmarkIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
	self.checkmarkIcon:SetSize(25, 22)	
    self.checkmarkIcon:SetPosition(self:GetWidth() / 2 - self.checkmarkIcon:GetWidth() / 2, self:GetHeight() / 2 - self.checkmarkIcon:GetHeight() / 2)
    self.checkmarkIcon:SetMouseVisible(false)
    self.checkmarkIcon:SetVisible(false)
    self.checkmarkIcon:SetBackground(0x410E3F4A)
    self.iconTable["Checkmark"] = self.checkmarkIcon

    self.undecidedIcon = Turbine.UI.Control()
    self.undecidedIcon:SetParent(self)
    self.undecidedIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.undecidedIcon:SetSize(64, 67)	
    self.undecidedIcon:SetPosition(self:GetWidth() / 2 - self.undecidedIcon:GetWidth() / 2, self:GetHeight() / 2 - self.undecidedIcon:GetHeight() / 2)
    self.undecidedIcon:SetMouseVisible(false)
    self.undecidedIcon:SetVisible(false)
    self.undecidedIcon:SetBackground(0x410D79FE)
    self.iconTable["Undecided"] = self.undecidedIcon

    self.readyIcon = Turbine.UI.Control()
    self.readyIcon:SetParent(self)
    self.readyIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.readyIcon:SetSize(64, 67)	
    self.readyIcon:SetPosition(self:GetWidth() / 2 - self.readyIcon:GetWidth() / 2, self:GetHeight() / 2 - self.readyIcon:GetHeight() / 2)
    self.readyIcon:SetMouseVisible(false)
    self.readyIcon:SetVisible(false)
    self.readyIcon:SetBackground(0x410D79FF)
    self.iconTable["Ready"] = self.readyIcon
    
    self.notReadyIcon = Turbine.UI.Control()
    self.notReadyIcon:SetParent(self)
    self.notReadyIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.notReadyIcon:SetSize(64, 67)	
    self.notReadyIcon:SetPosition(self:GetWidth() / 2 - self.notReadyIcon:GetWidth() / 2, self:GetHeight() / 2 - self.notReadyIcon:GetHeight() / 2)
    self.notReadyIcon:SetMouseVisible(false)
    self.notReadyIcon:SetVisible(false)
    self.notReadyIcon:SetBackground(0x410D7A00)
    self.iconTable["Not_Ready"] = self.notReadyIcon

    if leader or testMode then
        self.leaderIcon = Turbine.UI.Control()
        self.leaderIcon:SetParent(self)
        self.leaderIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
        self.leaderIcon:SetSize(16, 16)	
        self.leaderIcon:SetPosition(self.settings.Icon.Leader_X, self.settings.Icon.Leader_Y)
        self.leaderIcon:SetMouseVisible(false)
        self.leaderIcon:SetVisible(true)
        self.leaderIcon:SetBackground(0x41007DCE)
    end

    self.effectHandler = PrimeUITools.PrimeUIEffectListBox(self, self.settings.EffectBox.X, self.settings.EffectBox.Y, self.settings.EffectBox.Width, self.settings.EffectBox.Height, self.settings.EffectBox.Orientation, self.settings.EffectBox.Reversefill, self.settings.EffectBox.FlippedLayout, self.settings.EffectBox.ItemSize)
    if testMode then
        self.effectHandler:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
        self.effectHandler:SetBackColor(Turbine.UI.Color(0.5, 0, 0, 0))
    end

    self.boxTimers = {}
    self.boxTimers["Top Right"] = UI.BoxTimer(self, self:ColourTupleToTurbineColour(self.settings.Box_Timers.Top_Right_Box_Colour))
    self.boxTimers["Top Right"]:SetPosition(self:GetWidth() - self.boxTimers["Top Right"]:GetWidth() - self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize)

    self.boxTimers["Top Left"] = UI.BoxTimer(self, self:ColourTupleToTurbineColour(self.settings.Box_Timers.Top_Left_Box_Colour))
    self.boxTimers["Top Left"]:SetPosition(self.settings.Group_Frame.BorderSize, self.settings.Group_Frame.BorderSize)

    self.boxTimers["Bottom Right"] = UI.BoxTimer(self, self:ColourTupleToTurbineColour(self.settings.Box_Timers.Bottom_Right_Box_Colour))
    self.boxTimers["Bottom Right"]:SetPosition(self:GetWidth() - self.boxTimers["Bottom Right"]:GetWidth() - self.settings.Group_Frame.BorderSize, self:GetHeight() - self.boxTimers["Bottom Right"]:GetWidth() - self.settings.Group_Frame.BorderSize )

    self.boxTimers["Bottom Left"] = UI.BoxTimer(self, self:ColourTupleToTurbineColour(self.settings.Box_Timers.Bottom_Left_Box_Colour))
    self.boxTimers["Bottom Left"]:SetPosition(0, self:GetHeight() - self.boxTimers["Bottom Left"]:GetWidth() - self.settings.Group_Frame.BorderSize)

    self.currentEffects = {}
    self.SkillID = {}
    self.EffectCount = {}
    self.EffectQueue = Queue.new()
    self.EffectList = self.player:GetEffects()
    self.classFilter = self.settings.Effect_Conditions_Class[string.format("%s_White_List", ClassObjectToNameLUT[player:GetClass()])] or {}

    for i = 1, self.player:GetEffects():GetCount() do
        self:EffectFunction(self.EffectList:Get(i))
    end

    self.callbacks = {}

    self.effectcallback = AddCallback(self.EffectList, "EffectAdded", function(sender, args) self:EffectFunction(self.EffectList:Get(args.Index)) end)

    self.highlight = ClassSpecificTools.HighlightFrame3(self, 0, 0, self:GetWidth(), self:GetHeight(), self:ColourTupleToTurbineColour(self.settings.Player_Frame.Highlight_Colour), self.settings.Player_Frame.Highlight_Size)
    --self.highlight:ToggleHighlight(true)

    self.callbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function( sender, args ) self:HandleMorale() end)
    self.callbacks["MaxMoraleChanged"] = AddCallback(self.player, "MaxMoraleChanged", function( sender, args ) self:HandleMorale() end)
    self.callbacks["TemporaryMoraleChanged"] = AddCallback(self.player, "TemporaryMoraleChanged", function( sender, args ) self:HandleMorale() end)
    self:HandleMorale()

    if self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning then
        self.callbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function( sender, args ) self:HandlePower() end)
        self.callbacks["MaxPowerChanged"] = AddCallback(self.player, "MaxPowerChanged", function( sender, args ) self:HandlePower() end)
        self:HandlePower()
    end
end

function PlayerWindow:EffectFunction(effect)
    if self.currentEffects[effect:GetID()] then return end
    self.currentEffects[effect:GetID()] = true
    local name = effect:GetName()

    local value = self.classFilter[name] or self.settings.Effect_Conditions.Generic_White_List[name]

    if value then

        if value.Match_Icon and effect:GetIcon() ~= value.Icon then
            return
        end

        if self.EffectCount[name] then
            self.EffectCount[name] = self.EffectCount[name] + 1
        else
            self.EffectCount[name] = 1
        end

        if self.EffectCount[name] > value.Applications then
            local popID = Queue.popright(self.EffectQueue)
            self.effectHandler:Remove(self.SkillID[popID])
            self.SkillID[popID] = nil
            self.EffectCount[name] = self.EffectCount[name] - 1
        end
        

        local ID = effect:GetID()

        local effectItem = PrimeUITools.PrimeUIEffectBox(effect, self.settings.EffectBox.ItemSize, self.settings.EffectBox.Effect_Scale, self.settings.EffectBox.Spacing, 
        self.settings.EffectBox.BorderSize, self:ColourTupleToTurbineColour(self.settings.EffectBox.BorderColour), self.settings.EffectBox.Show_Duration, Turbine.UI.Lotro.Font[self.settings.EffectBox.Effect_Duration_Font], 
        Turbine.UI.ContentAlignment[self.settings.EffectBox.Effect_Duration_TextAlignment], self.settings.EffectBox.Visibility_Threshold, self.settings.EffectBox.Show_Stack, 
        Turbine.UI.Lotro.Font[self.settings.EffectBox.Effect_Stack_Font], Turbine.UI.ContentAlignment[self.settings.EffectBox.Effect_Stack_TextAlignment])

        self.effectHandler:Add(effectItem)

        self.SkillID[ID] = effectItem

        Queue.pushleft(self.EffectQueue, ID)
    end
end

function PlayerWindow:ColourTupleToTurbineColour(tuple)
    if tuple then
        if type(tuple[1]) == "table" then
            local colourTable = {}
            for key, value in pairs(tuple) do
                if value then
                    colourTable[key] = Turbine.UI.Color(value[1], value[2], value[3], value[4])
                else
                    colourTable[key] = nil
                end
            end

            return colourTable
        else
            return Turbine.UI.Color(tuple[1], tuple[2], tuple[3], tuple[4])
        end
    else
        return Turbine.UI.Color(0,0,0,0)
    end
end

function PlayerWindow:FontToFont(font)
    return Turbine.UI.Lotro.Font[font]
end


function PlayerWindow:TurnIconOff()
    for key, value in pairs(self.iconTable) do
        value:SetVisible(false)
    end
end 

function PlayerWindow:SetIconStatus(icon)
    if self.iconTable[icon] then
        self:TurnIconOff()
        self.iconTable[icon]:SetVisible(true)
    end
end

function PlayerWindow:StartBoxTimer(timerType, timer)
    if self.boxTimers[timerType] then
        self.boxTimers[timerType]:Start(timer)
    end
end

function PlayerWindow:Unload()
    for key, value in pairs(self.SkillID) do
        self.effectHandler:Remove(value)
    end
    self.effectHandler:Unload()
    for key, value in pairs(self.callbacks) do
        RemoveCallback(self.player, key, value)
        self.callbacks[key] = nil
    end
    if self.effectcallback then 
        RemoveCallback(self.EffectList, "EffectAdded", self.effectcallback)
        self.effectcallback = nil
    end
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    for key, _ in pairs(self) do
        self[key] = nil
    end
    self:SetParent(nil)
    collectgarbage()
end

function PlayerWindow:HandleMorale()
    local totalHealth = (self.player:GetMaxMorale() + self.player:GetTemporaryMorale())
    self.healthControl:SetWidth(self.healthBackgroundControl:GetSize() * (self.player:GetMorale() / totalHealth))	
    self.temporaryHealthControl:SetWidth(self.healthBackgroundControl:GetSize() * (self.player:GetTemporaryMorale() / totalHealth))
    self.temporaryHealthControl:SetLeft(self.healthBackgroundControl:GetWidth() - self.temporaryHealthControl:GetWidth() + self.settings.Group_Frame.BorderSize)
    self:SetHealthText()
end

function PlayerWindow:SetHealthText()
    local currentString = ""
    if self.settings.Health.HealthStringShowCurrent then
        currentString = string.format(self.settings.Health.HealthCurrentString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetMorale()))
    end

    local totalString = ""
    if self.settings.Health.HealthStringShowTotal then
        totalString = string.format(self.settings.Health.HealthTotalString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetMaxMorale()))
    end

    local tempString = ""
    if self.settings.Health.HealthTemporary and self.player:GetTemporaryMorale() > 0 then
        tempString = string.format(self.settings.Health.HealthTemporaryString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetTemporaryMorale()))
    end

    local percentageString = ""
    if self.settings.Health.HealthStringPercentage then
        percentageString = string.format(self.settings.Health.HealthPercentageString, PrimePlugins.RaidTools.Round(self.player:GetMorale() / self.player:GetMaxMorale() * 100,0))
    end

    self.healthLabel:SetText(string.format("%s%s%s%s", currentString, totalString, tempString, percentageString))
end

function PlayerWindow:HandlePower()
    self.powerControl:SetWidth(self.powerBackgroundControl:GetSize() * (self.player:GetPower() / self.player:GetMaxPower()))	
    self:SetPowerText()
end

function PlayerWindow:SetPowerText()
    local currentString = ""
    if self.settings.Power.PowerStringShowCurrent then
        currentString = string.format(self.settings.Power.PowerCurrentString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetPower()))
    end

    local totalString = ""
    if self.settings.Power.PowerStringShowTotal then
        totalString = string.format(self.settings.Power.PowerTotalString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetMaxPower()))
    end

    local tempString = ""
    if self.settings.Power.PowerTemporary and self.player:GetTemporaryPower() > 0 then
        tempString = string.format(self.settings.Power.PowerTemporaryString, PrimePlugins.RaidTools.FormatBigNumberVitals(self.player:GetTemporaryPower()))
    end

    local percentageString = ""
    if self.settings.Power.PowerStringPercentage then
        percentageString = string.format(self.settings.Power.PowerPercentageString, PrimePlugins.RaidTools.Round(self.player:GetPower() / self.player:GetMaxPower() * 100,0))
    end

    self.powerLabel:SetText(string.format("%s%s%s%s", currentString, totalString, tempString, percentageString))
end