LootHandlerObject = class(Turbine.Object)
function LootHandlerObject:Constructor()
    self.lootData = LoadTable(Turbine.DataScope.Server, "PrimeServerLootData")

    self.LootUpdate = function(sender, event, args)
        if type(event) == "function" then
            event(args)
        else
            if type(event) == "table" then
                for i = 1, #event do
                    if type(event[i]) == "function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    self.customLootNames = LoadTable(Turbine.DataScope.Account, "PrimeCustomLootNames") or {
        ["Quests"] = {},
        ["Instances"] = {},        
    }

    self.currentLootVersion = 1
    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    if self.lootData == nil or (self.lootData.Version and self.lootData.Version < self.currentLootVersion) or self.lootData.LastDailyReset == nil or self.lootData.LastWeeklyReset == nil then
        self.lootData = {
            ["Version"] = self.currentLootVersion,
            ["LootWeekly"] = {

            },
            ["LootDaily"] = {

            },
            ["LootChests"] = {

            },
            ["LastDailyReset"] = {
                ["Year"] = Turbine.Engine.GetDate().Year,
                ["DayOfWeek"] = Turbine.Engine.GetDate().DayOfWeek,
                ["Day"] = Turbine.Engine.GetDate().Day,
            },
            ["LastWeeklyReset"] = {
                ["Year"] = Turbine.Engine.GetDate().Year,
                ["DayOfWeek"] = Turbine.Engine.GetDate().DayOfWeek,
                ["DayOfYear"] = Turbine.Engine.GetDate().DayOfYear,
            }
        }
    end

    -- Reset daily
    if self.lootData.LastDailyReset.DayOfWeek ~= Turbine.Engine.GetDate().DayOfWeek or self.lootData.LastDailyReset.Day ~= Turbine.Engine.GetDate().Day or self.lootData.LastDailyReset.Year ~= Turbine.Engine.GetDate().Year then
        self.lootData.LootDaily = {}
        self.lootData.LastDailyReset = {
            ["Year"] = Turbine.Engine.GetDate().Year,
            ["DayOfWeek"] = Turbine.Engine.GetDate().DayOfWeek,
            ["Day"] = Turbine.Engine.GetDate().Day,
        }
        ChatOutput("Daily locks reset")
    end

    if 
    self.lootData.LastWeeklyReset.DayOfWeek == 1 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 4 or
    self.lootData.LastWeeklyReset.DayOfWeek == 2 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 3 or
    self.lootData.LastWeeklyReset.DayOfWeek == 3 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 2 or
    self.lootData.LastWeeklyReset.DayOfWeek == 4 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 1 or
    self.lootData.LastWeeklyReset.DayOfWeek == 5 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 7 or 
    self.lootData.LastWeeklyReset.DayOfWeek == 6 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 6 or
    self.lootData.LastWeeklyReset.DayOfWeek == 7 and (Turbine.Engine.GetDate().DayOfYear - self.lootData.LastWeeklyReset.DayOfYear) >= 5 or
    self.lootData.LastWeeklyReset.Year ~= Turbine.Engine.GetDate().Year then
        self.lootData.LootWeekly = {}
        self.lootData.LootChests = {}
        self.lootData.LastWeeklyReset = {
            ["DayOfWeek"] = Turbine.Engine.GetDate().DayOfWeek,
            ["DayOfYear"] = Turbine.Engine.GetDate().DayOfYear,
            ["Year"] = Turbine.Engine.GetDate().Year,
        }
        ChatOutput("Weekly locks reset")
    end   

    for instanceName, instanceData in pairs(self.lootData.LootChests) do
        for tier, tierData in pairs(instanceData) do
            for chestName, chestData in pairs(tierData) do
                for player, lockdata in pairs(chestData) do
                    if lockdata.Reset then
                        if lockdata.Reset < Turbine.Engine.GetLocalTime() then
                            self.lootData.LootChests[instanceName][tier] = nil
                        end
                    end
                end
            end
        end
    end

    self.chestNames = {
        -- Halls of Black Lore
        ["Past Adventures"] = {"Black Lore", 1},
        ["Fallen Foe"] = {"Black Lore", 2},
        ["Dolguzigir"] = {"Black Lore", 3},

        -- Kidzul Kalah
        ["Maid"] = {"Kidzul Kalah", 1},
        ["Dwarf Treasure"] = {"Kidzul Kalah", 2},

        -- The Fallen Kings
        ["The Witch King"] = {"The Fallen Kings", 1},
        -- House of Lamentation
        ["Manôzagar"] = {"House of Lamentation", 1},
        ["Narkhor"] = {"House of Lamentation", 2},
        ["Morloth"] = {"House of Lamentation", 3},
        ["Agath"] = {"House of Lamentation", 4},
        -- Roost
        ["Khúrthak"] = {"Roost", 1},
        ["Khatlob"] = {"Roost", 2},
        -- Harrowing
        ["Shaktur"] = {"Harrowing", 1},
        ["Dargásh"] = {"Harrowing", 2},
        -- TG
        ["Karkasht"] = {"Thikil-gundu", 1},
        ["Frór"] = {"Thikil-gundu", 2},
        ["Athramóth"] = {"Thikil-gundu", 3},
        ["Karazgar"] = {"Thikil-gundu", 4},
        -- Barrow
        ["Shalgoth"] = {"Barrows", 1},
        ["Gurzhorn"] = {"Barrows", 2},
        -- Shadowed king
        ["The King's Chest"] = {"Shadowed King", 1},
        -- Stair battle
        ["Shatarkha's"] = {"Stair", 1},
        ["Azbauz"] = {"Stair", 2},
        ["Groz"] = {"Stair", 3},
    
        ["Naruhel's Mithril"] = {"Spring vault", 1},
    
        -- Woe of the willow
        ["Dampmould"] = {"Woe of the willow", 1},
        ["Bombadil"] = {"Woe of the willow", 2},
    
        -- Narrowdelve
        ["Hoarpelt"] = {"Narrowdelve", 1},
        ["Ashen"] = {"Narrowdelve", 2},
        ["Storm"] = {"Narrowdelve", 3},
    
        -- Dhurstrok
        ["Gâdh%-and%-Shum"] = {"Dhúrstrok", 1},
        ["Mozrúk"] = {"Dhúrstrok", 2},
    
        -- Pughlak
        ["Kordkoth"] = {"Pughlak", 1},
        ["Pughlak"] = {"Pughlak", 2},
    
        -- Houses of Rest
        ["Risen Lords"] = {"Houses of Rest", 1},
        ["Loknashra"] = {"Houses of Rest", 2},
        ["Vethug"] = {"Houses of Rest", 3},

        -- 
        ["Fladach"] = {"Sarch Vorn", 1},
        ["Luilloth"] = {"Sarch Vorn", 2},
        ["Hithrengor"] = {"Sarch Vorn", 3},

        -- Sant Lhoer, the Poison Gardens
        ["Tarkka"] = {"Sant Lhoer, the Poison Gardens", 1},
        ["Grand Cultivator Oganuin"] = {"Sant Lhoer, the Poison Gardens", 2},

        -- Thaurisgar, the Vile Apothecary
        ["Aniochán's Puzzle"] = {"Thaurisgar, the Vile Apothecary", 1},
        ["Kurja and Kârsija"] = {"Thaurisgar, the Vile Apothecary", 2},

        -- Sagroth, Lair of Vermin
        ["Gárvadach"] = {"Sagroth, Lair of Vermin", 1},
        ["Rádarríg"] = {"Sagroth, Lair of Vermin", 2},

        -- Isle of Storms
        ["Krizhmûl"] = {"Isle of Storms", 1},
        ["Urâbaz"] = {"Isle of Storms", 2},
        ["Raghârik"] = {"Isle of Storms", 3},

        -- Arena
        ["Arena Neophyte"] = {"Arena", 1},
        ["Arena Veteran"] = {"Arena", 2},
        ["Arena Champion"] = {"Arena", 3},

        ["Utho"] = {"Streets", 1},
        ["Khâshap"] = {"Streets", 2},
    }

    self.raidChestNames = {
        -- Remmorchant
        ["Bratha"] = {"Remmorchant", 1},
        ["Gragarag"] = {"Remmorchant", 0},
        ["Guruthang"] = {"Remmorchant", 0},
        ["Gamnagol"] = {"Remmorchant", 0},
        ["Thossulun"] = {"Remmorchant", 2},
        ["Pale"] = {"Remmorchant", 3},
        ["Shelob"] = {"Remmorchant", 4},

        -- AD
        ["Beasts"] = {"Amdân Dammul", 1},
        ["Ránulur"] = {"Amdân Dammul", 2},

        -- FOKD
        ["Durin"] = {"Durin's Bane", 1},

        -- Hiddenhoard
        ["Thyrstáth's Tribute"] = {"Hiddenhoard", 1},
        ["Armaments of Ibkêrmazal"] = {"Hiddenhoard", 2},
        ["Hrímil Frost"] = {"Hiddenhoard", 3},

        -- Gwathrenost, the Witch-king's Citadel
        ["Gurkrak"] = {"Gwathrenost, the Witch-king's Citadel", 1},
        ["Obáshurz"] = {"Gwathrenost, the Witch-king's Citadel", 2},
        ["Ásachal and Claghórd"] = {"Gwathrenost, the Witch-king's Citadel", 3},
        ["Relics of Gwathrenost"] = {"Gwathrenost, the Witch-king's Citadel", 4},

        -- Deotgs
        ["Well-worn Corsair"] = {"The Depths of Mâkhda Khorbo", 1}, 
        ["Belondor"] = {"The Depths of Mâkhda Khorbo", 2},
        ["Forgotten Smuggler"] = {"The Depths of Mâkhda Khorbo", 3},
    }

    self.questNames = GetQuests()
end

function LootHandlerObject:GetBaseQuestData()
    return self.questNames
end

function LootHandlerObject:GetSpecialQuestData()
    return self.customLootNames.Quests
end

function LootHandlerObject:AddCustomQuest(questName, info)
    if self.customLootNames.Quests[questName] then
        return false
    else
        self.customLootNames.Quests[questName] = info
        return true
    end
end

function LootHandlerObject:RemoveCustomQuest(questName)
    self.customLootNames.Quests[questName] = nil
end

function LootHandlerObject:GetBaseInstanceData()
    local result = self.chestNames
    for key, value in pairs(self.raidChestNames) do
        result[key] = value
    end
    return result
end

function LootHandlerObject:GetSpecialInstanceData()
    return self.customLootNames.Instances
end

function LootHandlerObject:AddCustomInstance(chest, info)
    if self.customLootNames.Instances[chest] then
        return false
    else
        self.customLootNames.Instances[chest] = info
        return true
    end
end

function LootHandlerObject:RemoveCustomInstance(chest)
    self.customLootNames.Instances[chest] = nil
end

function LootHandlerObject:SaveLootData()
    SaveTable(Turbine.DataScope.Server, "PrimeServerLootData", self.lootData)
end

function LootHandlerObject:GetLootData()
    return self.lootData
end

function LootHandlerObject:LootlockParsing(message)

    if string.find(message, "completions remaining") and string.find(message, "Chest") then

        local chestName, tier, completionsRemaining, completionType = string.match(message, "(.*) Chest %- Tier (.*): You have (.*) (.*) completions remaining.")

        if chestName then
            tier = tonumber(tier)
            completionsRemaining = tonumber(completionsRemaining    )

            local instanceInfo = self:FindChest(chestName)

            if self.lootData.LootChests then
                if not(self.lootData.LootChests[instanceInfo[1]]) then
                    self.lootData.LootChests[instanceInfo[1]] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier]) then
                    self.lootData.LootChests[instanceInfo[1]][tier] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {}
                end

                self.LootUpdate(self, self.LootLockChanged, {
                    ["Instance_Name"] = instanceInfo[1],
                    ["Chest_Name"] = chestName,
                    ["Tier"] = tier,
                    ["CompletionsRemaining"] = completionsRemaining,
                    ["Type"] = completionType,
                    ["Order"] = instanceInfo[2],
                    ["Instance_Chest"] = true,
                    ["Quest_Lock"] = false,
                    ["Token"] = chestName,
                })

                self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {["CompletionsRemaining"] = completionsRemaining, ["Type"] = completionType, ["Order"] = instanceInfo[2]}
                return
            end


        end

        local chestName, day, hour, minutes = string.match(message, "(.*) Chest resets in: (.*)d %- (.*)h %- (.*)m.")

        if chestName then

            local instanceInfo = self:FindChest(chestName)

            local tier, chestName = self:FindChestTier(chestName)

            if self.lootData.LootChests then
                if not(self.lootData.LootChests[instanceInfo[1]]) then
                    self.lootData.LootChests[instanceInfo[1]] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier]) then
                    self.lootData.LootChests[instanceInfo[1]][tier] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {}
                end

                self.LootUpdate(self, self.LootLockChanged, {
                    ["Instance_Name"] = instanceInfo[1],
                    ["Chest_Name"] = chestName,
                    ["Tier"] = tier,
                    ["CompletionsRemaining"] = 0,
                    ["Order"] = instanceInfo[2],
                    ["Reset"] = Turbine.Engine.GetLocalTime() + tonumber(day) * 86400 + tonumber(hour) * 3600 + tonumber(minutes),
                    ["Instance_Chest"] = true,
                    ["Quest_Lock"] = false,
                    ["Token"] = chestName,
                })

                self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {["CompletionsRemaining"] = 0, ["Order"] = instanceInfo[2], ["Reset"] = Turbine.Engine.GetLocalTime() + tonumber(day) * 86400 + tonumber(hour) * 3600 + tonumber(minutes)}
                return
            end
        end

    elseif string.find(message, "Tier") then

        local chestName, tier, day, hour, minutes = string.match(message, "(.*) - Tier (.*) resets in: (.*)d %- (.*)h %- (.*)m.")

        if chestName then

            chestName = chestName:gsub("'s Chest %-", "")

            local instanceInfo = self:FindChest(chestName)

            if self.lootData.LootChests then
                if not(self.lootData.LootChests[instanceInfo[1]]) then
                    self.lootData.LootChests[instanceInfo[1]] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier]) then
                    self.lootData.LootChests[instanceInfo[1]][tier] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName] = {}
                end

                if not(self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName]) then
                    self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {}
                end

                
                self.LootUpdate(self, self.LootLockChanged, {
                    ["Instance_Name"] = instanceInfo[1],
                    ["Chest_Name"] = chestName,
                    ["Tier"] = tier,
                    ["CompletionsRemaining"] = 0,
                    ["Order"] = instanceInfo[2],
                    ["Reset"] = Turbine.Engine.GetLocalTime() + tonumber(day) * 86400 + tonumber(hour) * 3600 + tonumber(minutes),
                    ["Instance_Chest"] = true,
                    ["Quest_Lock"] = false,
                    ["Token"] = chestName,
                })

                self.lootData.LootChests[instanceInfo[1]][tier][chestName][self.playerName] = {["CompletionsRemaining"] = 0, ["Order"] = instanceInfo[2], ["Reset"] = Turbine.Engine.GetLocalTime() + tonumber(day) * 86400 + tonumber(hour) * 3600 + tonumber(minutes)}
                return
            end
        end
    end
end

function LootHandlerObject:FindChest(chestName)
    local instanceInfo = {"Misc", 0}

    for key, value in pairs(self.chestNames) do
        if string.find(chestName, key) then
            instanceInfo = value
            break
        end
    end

    for key, value in pairs(self.raidChestNames) do
        if string.find(chestName, key) then
            
            instanceInfo = value
            break
        end
    end

    return instanceInfo
end

function LootHandlerObject:FindChestTier(chestName)
    if string.find(chestName, "Silver") then return 1, string.match(chestName, "(.*) Silver") end
    if string.find(chestName, "Gold") then return 1, string.match(chestName, "(.*) Gold") end
    if string.find(chestName, "Mithril") then return 1, string.match(chestName, "(.*) Mithril") end
    return 0, chestName
end

function LootHandlerObject:QuestParsing(message)
    local questData = self.customLootNames.Quests[message] or self.questNames[message]

    if questData then
        if questData[2] == 1 then
            if self.lootData.LootDaily then
                if not(self.lootData.LootDaily[questData[1]]) then
                    self.lootData.LootDaily[questData[1]] = {}
                end

                if not(self.lootData.LootDaily[questData[1]][self.playerName]) then
                    self.lootData.LootDaily[questData[1]][self.playerName] = {}
                end

                self.lootData.LootDaily[questData[1]][self.playerName] = 0

                self.LootUpdate(self, self.LootLockChanged, {
                    ["Quest_Name"] = questData[1],
                    ["Quest_Lock"] = true,
                    ["Reset_Type"] = "Daily",
                    ["Token"] = questData[1],
                })
            end
        elseif questData[2] == 2 then
            if self.lootData.LootWeekly then
                if not(self.lootData.LootWeekly[questData[1]]) then
                    self.lootData.LootWeekly[questData[1]] = {}
                end

                if not(self.lootData.LootWeekly[questData[1]][self.playerName]) then
                    self.lootData.LootWeekly[questData[1]][self.playerName] = {}
                end

                self.lootData.LootWeekly[questData[1]][self.playerName] = 0

                self.LootUpdate(self, self.LootLockChanged, {
                    ["Quest_Name"] = questData[1],
                    ["Quest_Lock"] = true,
                    ["Reset_Type"] = "Weekly",
                    ["Token"] = questData[1],
                })
            end
        end
    end
end

function LootHandlerObject:GetLockStatus(label)

    local questLock = 
        self.lootData.LootWeekly[label] and self.lootData.LootWeekly[label][self.playerName] or
        self.lootData.LootDaily[label] and self.lootData.LootDaily[label][self.playerName] or nil

    if not questLock then
        for instanceName, tierData in pairs(self.lootData.LootChests) do
            for tier, chestData in pairs(tierData) do
                for chest, nameData in pairs(chestData) do
                    if chest == label and nameData[self.playerName] then
                        return nameData[self.playerName]
                    end
                end
            end
        end
    else
        return questLock
    end
end

function LootHandlerObject:Unload()
    SaveTable(Turbine.DataScope.Server, "PrimeServerLootData", self.lootData)
    SaveTable(Turbine.DataScope.Account, "PrimeCustomLootNames", self.customLootNames)
end