LootOptions = class(Turbine.UI.Control)
function LootOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 550
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height)
    self:SetPosition(0, 0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    -- Quests
    self.questBorder = Turbine.UI.Control()
    self.questBorder:SetParent(self)
    self.questBorder:SetSize(self:GetWidth(), 200)
    self.questBorder:SetBackColor(Turbine.UI.Color.Black)

    self.questBackground = Turbine.UI.Control()
    self.questBackground:SetParent(self.questBorder)
    self.questBackground:SetSize(self.questBorder:GetWidth() - 4, self.questBorder:GetHeight() - 4)
    self.questBackground:SetPosition(2, 2)
    self.questBackground:SetBackColor(Turbine.UI.Color(0.21,0.21,0.21))

    self.questLabel = Turbine.UI.Label()
    self.questLabel:SetParent(self.questBackground)
    self.questLabel:SetSize(100, 20)
    self.questLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.questLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.questLabel:SetText("Quests")

    self.questBox = Turbine.UI.ListBox()
    self.questBox:SetParent(self.questBackground)
    self.questBox:SetPosition(0, 40)
    --self.questBox:SetBackColor(Turbine.UI.Color.Goldenrod)
    self.questBox:SetSize(self.questBackground:GetWidth() - 10, self.questBackground:GetHeight() - 40)

    self.questBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.questBoxScrollbar:SetParent(self.questBackground)
    self.questBoxScrollbar:SetPosition(self.questBackground:GetWidth() - 10, 40)
    self.questBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.questBoxScrollbar:SetSize(10, self.questBackground:GetHeight() - 40)
    self.questBox:SetVerticalScrollBar(self.questBoxScrollbar)

    self.addListboxQuestItem = function(questName, item, special)
        local controlBar = Turbine.UI.Control()
        controlBar:SetSize(self.questBox:GetWidth(), 24)
        controlBar:SetBackColor(Turbine.UI.Color.Black)

        controlBar.label = Turbine.UI.Label()
        controlBar.label:SetParent(controlBar)
        controlBar.label:SetPosition(0, 2)
        controlBar.label:SetSize(self.questBox:GetWidth() - 4, 20)
        controlBar.label:SetBackColor(Turbine.UI.Color(0.1,0.14,0.14))
        controlBar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        controlBar.label:SetText(string.format("QUEST NAME [%s] LABEL [%s] RESET [%s]", questName, item[1], item[2] == 2 and "Weekly" or "Daily"))

        if special then
            controlBar.removalButton = Turbine.UI.Lotro.Button()
            controlBar.removalButton:SetParent(controlBar)
            controlBar.removalButton:SetText("Remove")
            controlBar.removalButton:SetPosition(self.questBox:GetWidth() - 50, 0)

            controlBar.removalButton.Click = function()
                LootHandler:RemoveCustomQuest(questName)
                self.questBox:RemoveItem(controlBar)
            end
            
        end

        return controlBar
    end

    if LootHandler then
        for key, value in spairs(LootHandler:GetSpecialQuestData(), function(t, a, b) return a < b end) do
            self.questBox:AddItem(self.addListboxQuestItem(key, value, true))
        end

        for key, value in spairs(LootHandler:GetBaseQuestData(), function(t, a, b) return a < b end) do
            self.questBox:AddItem(self.addListboxQuestItem(key, value))
        end
    end


    self.questTextBox = Turbine.UI.Lotro.TextBox()
    self.questTextBox:SetParent(self.questBackground)
    self.questTextBox:SetPosition(100, 0)
    self.questTextBox:SetSize(500, 20)
    self.questTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.questTextBox:SetText("Quest Name")

    self.questLabelTextBox = Turbine.UI.Lotro.TextBox()
    self.questLabelTextBox:SetParent(self.questBackground)
    self.questLabelTextBox:SetPosition(100, 20)
    self.questLabelTextBox:SetSize(500, 20)
    self.questLabelTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.questLabelTextBox:SetText("Label")

    self.questDailyCheckbox = Turbine.UI.Lotro.CheckBox()
    self.questDailyCheckbox:SetParent(self.questBackground)
    self.questDailyCheckbox:SetPosition(600, 0)
    self.questDailyCheckbox:SetSize(100, 20)
    self.questDailyCheckbox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.questDailyCheckbox:SetText("Daily")

    self.questWeeklyCheckbox = Turbine.UI.Lotro.CheckBox()
    self.questWeeklyCheckbox:SetParent(self.questBackground)
    self.questWeeklyCheckbox:SetPosition(600, 20)
    self.questWeeklyCheckbox:SetSize(100, 20)
    self.questWeeklyCheckbox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.questWeeklyCheckbox:SetText("Weekly")

    self.questWeeklyCheckbox.CheckedChanged = function()
        if self.questWeeklyCheckbox:IsChecked() and self.questDailyCheckbox:IsChecked() then
            self.questDailyCheckbox:SetChecked(false)
        end
    end

    self.questDailyCheckbox.CheckedChanged = function()
        if self.questWeeklyCheckbox:IsChecked() and self.questDailyCheckbox:IsChecked() then
            self.questWeeklyCheckbox:SetChecked(false)
        end
    end

    self.questAddButton = Turbine.UI.Lotro.Button()
    self.questAddButton:SetParent(self.questBackground)
    self.questAddButton:SetText("Add")
    self.questAddButton:SetPosition(670, 10)

    self.questAddButton.Click = function()

        local questName = tostring(self.questTextBox:GetText())
        local label = tostring(self.questLabelTextBox:GetText())

        local resetType = self.questDailyCheckbox:IsChecked() and 1 or self.questWeeklyCheckbox:IsChecked() and 2 or 1

        if LootHandler:AddCustomQuest(questName, {label, tonumber(resetType) or 1}) then
            self.questBox:AddItem(self.addListboxQuestItem(questName, {label, tonumber(resetType) or 1}, true))
            ChatOutput(string.format("Added: Quest Name: [%s] Label: [%s] Reset [%s]", questName, label, resetType))
        else
            ChatOutput(string.format("Failed to add: Quest Name: [%s], this quest tracker already exists", questName))
        end
    end

    -- Instances
    self.instanceBorder = Turbine.UI.Control()
    self.instanceBorder:SetParent(self)
    self.instanceBorder:SetSize(self:GetWidth(), 300)
    self.instanceBorder:SetBackColor(Turbine.UI.Color.Black)
    self.instanceBorder:SetPosition(0, self.questBorder:GetHeight())

    self.instanceBackground = Turbine.UI.Control()
    self.instanceBackground:SetParent(self.instanceBorder)
    self.instanceBackground:SetSize(self.instanceBorder:GetWidth() - 4, self.instanceBorder:GetHeight() - 4)
    self.instanceBackground:SetPosition(2, 2)
    self.instanceBackground:SetBackColor(Turbine.UI.Color(0.21,0.21,0.21))

    self.instanceLabel = Turbine.UI.Label()
    self.instanceLabel:SetParent(self.instanceBackground)
    self.instanceLabel:SetSize(100, 20)
    self.instanceLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.instanceLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.instanceLabel:SetText("Instances")

    self.instanceBox = Turbine.UI.ListBox()
    self.instanceBox:SetParent(self.instanceBackground)
    self.instanceBox:SetPosition(0, 40)
    --self.instanceBox:SetBackColor(Turbine.UI.Color.Goldenrod)
    self.instanceBox:SetSize(self.instanceBackground:GetWidth() - 10, self.instanceBackground:GetHeight() - 40)

    self.instanceBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.instanceBoxScrollbar:SetParent(self.instanceBackground)
    self.instanceBoxScrollbar:SetPosition(self.instanceBackground:GetWidth() - 10, 40)
    self.instanceBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.instanceBoxScrollbar:SetSize(10, self.instanceBackground:GetHeight() - 40)
    self.instanceBox:SetVerticalScrollBar(self.instanceBoxScrollbar)

    self.addListboxinstanceItem = function(instanceName, item, special)
        local controlBar = Turbine.UI.Control()
        controlBar:SetSize(self.instanceBox:GetWidth(), 24)
        controlBar:SetBackColor(Turbine.UI.Color.Black)

        controlBar.label = Turbine.UI.Label()
        controlBar.label:SetParent(controlBar)
        controlBar.label:SetPosition(0, 2)
        controlBar.label:SetSize(self.instanceBox:GetWidth() - 4, 20)
        controlBar.label:SetBackColor(Turbine.UI.Color(0.1,0.14,0.14))
        controlBar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        controlBar.label:SetMarkupEnabled(true)
        controlBar.label:SetText(string.format("CHEST NAME [%s] INSTANCE NAME [%s] #[%s]", instanceName, item[1], item[2]))

        if special then
            controlBar.removalButton = Turbine.UI.Lotro.Button()
            controlBar.removalButton:SetParent(controlBar)
            controlBar.removalButton:SetText("Remove")
            controlBar.removalButton:SetPosition(self.instanceBox:GetWidth() - 50, 0)

            controlBar.removalButton.Click = function()
                LootHandler:RemoveCustomInstance(instanceName)
                self.instanceBox:RemoveItem(controlBar)
            end
            
        end

        return controlBar
    end

    if LootHandler then
        for key, value in spairs(LootHandler:GetSpecialInstanceData(), function(t, a, b) return t[a][1] < t[b][1] end) do
            self.instanceBox:AddItem(self.addListboxinstanceItem(key, value, true))
        end

        for key, value in spairs(LootHandler:GetBaseInstanceData(), function(t, a, b) return t[a][1] < t[b][1] end) do
            self.instanceBox:AddItem(self.addListboxinstanceItem(key, value))
        end
    end


    self.instanceTextBox = Turbine.UI.Lotro.TextBox()
    self.instanceTextBox:SetParent(self.instanceBackground)
    self.instanceTextBox:SetPosition(100, 0)
    self.instanceTextBox:SetSize(500, 20)
    self.instanceTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.instanceTextBox:SetText("Chest Name")

    self.instanceLabelTextBox = Turbine.UI.Lotro.TextBox()
    self.instanceLabelTextBox:SetParent(self.instanceBackground)
    self.instanceLabelTextBox:SetPosition(100, 20)
    self.instanceLabelTextBox:SetSize(500, 20)
    self.instanceLabelTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.instanceLabelTextBox:SetText("Instance Name")

    self.instanceNumberTextBox = Turbine.UI.Lotro.TextBox()
    self.instanceNumberTextBox:SetParent(self.instanceBackground)
    self.instanceNumberTextBox:SetPosition(600, 10)
    self.instanceNumberTextBox:SetSize(50, 20)
    self.instanceNumberTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.instanceNumberTextBox:SetText("#")

    self.instanceAddButton = Turbine.UI.Lotro.Button()
    self.instanceAddButton:SetParent(self.instanceBackground)
    self.instanceAddButton:SetText("Add")
    self.instanceAddButton:SetPosition(670, 10)

    self.instanceAddButton.Click = function()

        local chestName = tostring(self.instanceTextBox:GetText()) or ""
        local instanceName = tostring(self.instanceLabelTextBox:GetText()) or ""
        local number = tonumber(self.instanceNumberTextBox:GetText()) or 1

        if LootHandler:AddCustomInstance(chestName, {instanceName, tonumber(number) or 1}) then
            self.instanceBox:AddItem(self.addListboxinstanceItem(chestName, {instanceName, tonumber(number) or 1}, true))
            ChatOutput(string.format("Added: Chest Name: [%s] Instance Name: [%s] #[%s]", chestName, instanceName, number))
        else
            ChatOutput(string.format("Failed to add: Chest Name: [%s], this instance tracker already exists", chestName))
        end
    end
end