function GetWindowUI(parent, text, height, settingX, settingY)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(400, 35)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0)
    UIElement.windowLabel:SetSize(200,15)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText(text)

    UIElement.windowX = Turbine.UI.TextBox()
    UIElement.windowX:SetParent(UIElement)
    UIElement.windowX:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowX:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowX:SetPosition(20 , 15)
    UIElement.windowX:SetSize(100,15)
    UIElement.windowX:SetText(settingX)
    UIElement.windowX:SetVisible(true)

    UIElement.windowY = Turbine.UI.TextBox()
    UIElement.windowY:SetParent(UIElement)
    UIElement.windowY:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowY:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowY:SetPosition(130 , 15)
    UIElement.windowY:SetSize(100,15)
    UIElement.windowY:SetText(settingY)
    UIElement.windowY:SetVisible(true)

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(240 , 10)
    UIElement.button:SetSize(100,15)
    UIElement.button:SetText("Apply change")
    UIElement.button:SetVisible(true)

    return(UIElement)
end

function GetLabelUI(parent, text, height)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(600, 30)
    -- NoteWindow
    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0)
    UIElement.windowLabel:SetSize(600,30)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText(text)
    return(UIElement)
end

function GetCheckUI(parent, height, text, checked)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(200, 40)

    UIElement.cBox = Turbine.UI.Lotro.CheckBox()
    UIElement.cBox:SetParent(UIElement)
    UIElement.cBox:SetPosition(15 , 0)
    UIElement.cBox:SetSize(300,40)
    UIElement.cBox:SetChecked(checked)
    UIElement.cBox:SetText(text)
    UIElement.cBox:SetVisible(true)
    return(UIElement)
end

function GetFontMenu(parent, height, text)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(400, 50)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(0 , 10)
    UIElement.windowLabel:SetSize(200,15)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText("Change font")

    UIElement.menu = Turbine.UI.ContextMenu()
    UIElement.menuItems = UIElement.menu:GetItems()
    for i, fontName in pairs( Fonts ) do
        local menuItem = Turbine.UI.MenuItem( fontName )
        UIElement.menuItems:Add(menuItem)
        --ChatOutput(fontName)
     end

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(0, 30)
    UIElement.button:SetSize(200,15)
    UIElement.button:SetText(text)
    UIElement.button:SetVisible(true)

    UIElement.button.Click = function()
        UIElement.menu:ShowMenu()
    end

     return(UIElement)
end

Fonts = {}
FontsLUT = {}
FontsLUTR = {}
for key, item in pairs(Turbine.UI.Lotro.Font) do
    if ( item ~= "IsA" and item ~= "Undefined" ) then
       table.insert(Fonts, key)
       
       FontsLUT[key] = item
       FontsLUTR[item] = key

    end
end
table.sort(Fonts)

plugin.GetOptionsPanel = function( self )
    local options = Turbine.UI.Control()
    options:SetSize(500, 400)

    local MasterOptionsButton = Turbine.UI.Lotro.Button()
    MasterOptionsButton:SetParent(options)
    MasterOptionsButton:SetPosition(100, 100)
    MasterOptionsButton:SetSize(200,15)
    MasterOptionsButton:SetText("Open options panel")
    MasterOptionsButton:SetVisible(true)

    MasterOptionsButton.Click = function()
        if MasterOptions == nil then
            MasterOptions = OptionOptions()
        else
            MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
        end
    end

    return options
end

function SetCommands()
    Command = Turbine.ShellCommand()

    function Command:Execute(commandName, commandString)

        local commandCategory, commandArgs = string.match(commandString, "(%a+) (.*)")

        if not commandCategory then
            commandCategory = commandString
        end

        if commandCategory then
            if commandCategory == "help" then
                CommandOutput("prime reload - Reloads the plugin")
                CommandOutput("prime soundtest - Test the soundplayer")
                CommandOutput("prime ready - Show readycheck button")
                CommandOutput("prime settings list - List all the settings")
                CommandOutput("prime settings get [key] - Searches and outputs the settings that (partially) match the key")
                CommandOutput("prime settings set [key] - Sets the setting for a specific key, only supports booleans, numbers and strings")
                CommandOutput("prime settings reset - Resets your settings to the base value")
                CommandOutput("prime runscript [code] - Compiles and runs code")
            elseif commandCategory == "reload" then
                CommandOutput("Executing reloading command")
                ReloadPlugin()
            elseif commandCategory == "soundtest" then
                CommandOutput("Executing sound test command")
                Sounds:PlaySoundEffect(Sounds:GetSoundList()["Test"])
            elseif commandCategory == "ready" then
                CommandOutput("Executing readycheck command")
                if Party ~= nil then
                    if Party:GetLeader():GetName() == Player:GetName() then
                        RCButtonWindow:SetVisible(true)
                    end
                else
                    ThrowException("You are not in a party!")
                end
            elseif commandCategory == "settings" then
                if string.find(commandArgs, "list") then
                    for key, value in spairs(Settings, function(t, a, b) return a < b end) do
                        CommandOutput(string.format("%s [%s] %s", tostring(key), tostring(type(value)), tostring(value)))
                    end
                elseif string.find(commandArgs, "get") then
                    local settingsKey = string.match(commandArgs, "get (.*)")
                    if settingsKey then
                        CommandOutput(string.format("Searching settings items for key %s", tostring(settingsKey)))
                        for key, value in pairs(Settings) do
                            if string.find(key, settingsKey) then
                                CommandOutput(string.format("%s [%s] %s", tostring(key), tostring(type(Settings[key])), tostring(Settings[key])))
                            end
                        end
                    end
                elseif string.find(commandArgs, "set") then
                    local settingsKey, settingsValue = string.match(commandArgs, "get (.*) (.*)")
                    if settingsKey and settingsValue then
                        if Settings[settingsKey] then
                            local valueType = type(Settings[settingsKey])
                            if valueType == "string" then
                                Settings[settingsKey] = tostring(settingsValue)
                                CommandOutput(string.format("Set settings %s to value ", settingsKey, tostring(settingsValue)))
                            elseif valueType == "number" then
                                if tonumber(settingsValue) then
                                    Settings[settingsKey] = tonumber(settingsValue)
                                    CommandOutput(string.format("Set settings %s to value ", settingsKey, tonumber(settingsValue)))
                                else
                                    CommandOutput("Failed conversion")
                                end
                            elseif valueType == "boolean" then
                                if settingsValue == tostring(true) then
                                    Settings[settingsKey] = true
                                elseif settingsValue == tostring(false) then
                                    Settings[settingsKey] = false
                                end
                            else
                                CommandOutput("Unsupported type")
                            end

                        else
                            CommandOutput("Invalid key")
                        end
                    else
                        CommandOutput("Invalid key or value")
                    end
                elseif  commandArgs == "reset" then
                    CommandOutput("Attempting to reset settings")
                    GetDefaultSettings()
                    CommandOutput("Successfully reset settings")
                    ReloadPlugin()
                end
            elseif commandCategory == "runScript" then
                local code = string.match(commandString, "runScript (.*)")
                if code then
                    local result, func = pcall(loadstring, string.format("return function() %s end", code))
                    if result then
                        local createdFunction = func()
                        local functionEnv = {
                            Turbine = Turbine,
                        }
                        setfenv(createdFunction, functionEnv)
                        createdFunction()
                        CommandOutput("Executed code")
                    else
                        CommandOutput(string.format("Failed to compile code: %s", func))
                    end
                else
                    CommandOutput("Failed to get code")
                end
            else
                CommandOutput("No existing command found")
            end
        end
    end
    
    Turbine.Shell.AddCommand("prime", Command)
end

-- Define a tree node class to put into the tree.
MyTreeNode = class( Turbine.UI.TreeNode )
function MyTreeNode:Constructor(text, leaf)
    Turbine.UI.TreeNode.Constructor( self )
    --self:SetBackColor( Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetSize( 220, 18 )

    self:SetVisible(true)
    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(true)

    local xPos = 0

    if not(leaf) then
        self.tickLabel = Turbine.UI.Label()
        self.tickLabel:SetVisible(true)
        self.tickLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        --self.tickLabel:SetForeColor(colour)
        self.tickLabel:SetParent(self)
        self.tickLabel:SetSize(16, 16)
        self.tickLabel:SetPosition(0, 0)
        self.tickLabel:SetWantsKeyEvents(false)
        self.tickLabel:SetMouseVisible(false)
        self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Plus.jpg")
        xPos = 18
    end

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetVisible(true)
    self.nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.nameLabel:SetForeColor(colour)
    self.nameLabel:SetParent(self)
    self.nameLabel:SetSize(220, 18)
    self.nameLabel:SetPosition(xPos, 0)
    self.nameLabel:SetWantsKeyEvents(false)
    self.nameLabel:SetMouseVisible(false)
    self.nameLabel:SetMarkupEnabled(true)
    self.nameLabel:SetText(text)

    self.ChangeBackground = function()
        if self:IsExpanded() then
            self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Min.jpg")
        else
            self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Plus.jpg")
        end
    end
end
