function PrimeUI:Conditions2(data, parent)
    local valuebar = Turbine.UI.Window()
    valuebar:SetParent(parent)

    valuebar.togglefunction = function(value)
        if value then
            for keyword in string.gmatch(data.Activation_Triggers, "([^,]+)") do
                self:FireTrigger(keyword)
            end
        else
            for keyword in string.gmatch(data.Deactivation_Triggers, "([^,]+)") do
                self:FireTrigger(keyword)
            end
        end
    end

    valuebar.rewrittenConditionsTable = {}

    local thresholdNumber = 0

    -- rewrite table

    local conditionTable = {}

    conditionTable["In_Combat"] = data.Condition_In_Combat
    conditionTable["Out_Of_Combat"] = data.Condition_Out_Of_Combat

    thresholdNumber = thresholdNumber + (data.Condition_In_Combat and 1 or 0)
    thresholdNumber = thresholdNumber + (data.Condition_Out_Of_Combat and 1 or 0)

    conditionTable["Mounted"] = data.Condition_Mounted
    conditionTable["Non_Mounted"] = data.Condition_Not_Mounted

    thresholdNumber = thresholdNumber + (data.Condition_Mounted and 1 or 0)
    thresholdNumber = thresholdNumber + (data.Condition_Not_Mounted and 1 or 0)

    conditionTable["Role"] = {
        ["Tank"] = data.Condition_Role_Tank,
        ["Support"] = data.Condition_Role_Support,
        ["Heal"] = data.Condition_Role_Heal,
        ["DPS"] = data.Condition_Role_DPS,
    }

    local roleCondition = false
    for key, value in pairs(conditionTable["Role"]) do
        if value then
            roleCondition = true
        end
    end
    thresholdNumber = thresholdNumber + (roleCondition and 1 or 0)


    conditionTable["Class"] = {
        ["Class_Match"] = {
            ["Brawler"] = data.Condition_Class_Brawler,
            ["Captain"] = data.Condition_Class_Captain,
            ["Champion"] = data.Condition_Class_Champion,
            ["Mariner"] = data.Condition_Class_Mariner,
            ["Guardian"] = data.Condition_Class_Guardian,
            ["Hunter"] = data.Condition_Class_Hunter,
            ["LoreMaster"] = data.Condition_Class_LoreMaster,
            ["Minstrel"] = data.Condition_Class_Minstrel,
            ["RuneKeeper"] = data.Condition_Class_RuneKeeper,
            ["Warden"] = data.Condition_Class_Warden,
            ["Beorning"] = data.Condition_Class_Beorning,
            ["BlackArrow"] = data.Condition_Class_BlackArrow,
            ["Defiler"] = data.Condition_Class_Defiler,
            ["Reaver"] = data.Condition_Class_Reaver,
            ["Stalker"] = data.Condition_Class_Stalker,
            ["WarLeader"] = data.Condition_Class_WarLeader,
            ["Weaver"] = data.Condition_Class_Weaver,
            ["Troll"] = data.Condition_Class_Troll,
            ["Chicken"] = data.Condition_Class_Chicken,
            ["Ranger"] = data.Condition_Class_Ranger,
        }
    }

    local classCondition = false
    for key, value in pairs(conditionTable["Class"]["Class_Match"]) do
        if value then
            classCondition = true
        end
    end
    thresholdNumber = thresholdNumber + (classCondition and 1 or 0)

    conditionTable["Line"] = {
        ["Blue"] = data.Condition_Line_Blue,
        ["Red"] = data.Condition_Line_Red,
        ["Yellow"] = data.Condition_Line_Yellow,
    }

    local lineCondition = false
    for key, value in pairs(conditionTable["Line"]) do
        if value then
            lineCondition = true
        end
    end
    thresholdNumber = thresholdNumber + (lineCondition and 1 or 0)

    conditionTable["Status"] = {
        ["Disease"] = data.Condition_Status_Disease,
        ["Physical"] = data.Condition_Status_Physical,
        ["Wound"] = data.Condition_Status_Wound,
        ["Cry"] = data.Condition_Status_Cry,
        ["Song"] = data.Condition_Status_Song,
        ["Fear"] = data.Condition_Status_Fear,
        ["Poison"] = data.Condition_Status_Poison,
        ["Tactical"] = data.Condition_Status_Tactical,
        ["Elemental"] = data.Condition_Status_Elemental,
        ["Corruption"] = data.Condition_Status_Corruption,
        ["Dispellable"] = data.Condition_Status_Dispellable,
    }     

    local statusCondition = false
    for key, value in pairs(conditionTable["Status"]) do
        if value then
            statusCondition = true
        end
    end
    thresholdNumber = thresholdNumber + (statusCondition and 1 or 0)

    conditionTable["Race"] = {
        ["Beorning"] = data.Condition_Race_Beorning,
        ["Dwarf"] = data.Condition_Race_Dwarf,
        ["Elf"] = data.Condition_Race_Elf,
        ["HighElf"] = data.Condition_Race_HighElf,
        ["Hobbit"] = data.Condition_Race_Hobbit,
        ["Man"] = data.Condition_Race_Man,
        ["StoutAxe"] = data.Condition_Race_StoutAxe,
    }     

    local statusCondition = false
    for key, value in pairs(conditionTable["Race"]) do
        if value then
            statusCondition = true
        end
    end
    thresholdNumber = thresholdNumber + (statusCondition and 1 or 0)

    for key, value in pairs(conditionTable) do
        if(type(value) == "table") then
            for key2, value2 in pairs(value) do
                if(type(value2) == "table") then
                    for key3, value3 in pairs(value2) do
                        if value3 == true then
                            if not valuebar.rewrittenConditionsTable[key] then valuebar.rewrittenConditionsTable[key] = {} end
                            if not valuebar.rewrittenConditionsTable[key][key2] then valuebar.rewrittenConditionsTable[key][key2] = {} end
                            valuebar.rewrittenConditionsTable[key][key2][key3] = value3
                        end
                    end
                elseif value2 == true then
                    if not valuebar.rewrittenConditionsTable[key] then valuebar.rewrittenConditionsTable[key] = {} end
                    valuebar.rewrittenConditionsTable[key][key2] = value2
                end
            end
        elseif value == true then
            valuebar.rewrittenConditionsTable[key] = value
        end

    end

    if tablelength(data["Effects"]) > 0 then
        valuebar.rewrittenConditionsTable["Effects"] = {}
        for key, value in pairs(data["Effects"]) do
            valuebar.rewrittenConditionsTable["Effects"][key] = {
                ["Applications"] = value.Applications,
                ["Not_Applied"] = value.Not_Applied,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Location"]) > 0 then
        valuebar.rewrittenConditionsTable["Location"] = {}
        for key, value in pairs(data["Location"]) do
            valuebar.rewrittenConditionsTable["Location"][key] = true
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Event_Trigger"]) > 0 then
        valuebar.rewrittenConditionsTable["EventTrigger"] = {}
        for key, value in pairs(data["Event_Trigger"]) do
            valuebar.rewrittenConditionsTable["EventTrigger"][key] = {
                ["Not_Applied"] = value.Not_Applied,
                ["Timer"] = value.Time,
                ["Variable_Name"] = value.Condition_Name
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Event_Variable"]) > 0 then
        valuebar.rewrittenConditionsTable["EventVariable"] = {}
        for key, value in pairs(data["Event_Variable"]) do
            valuebar.rewrittenConditionsTable["EventVariable"][key] = {
                ["Value"] = value.Value,
                ["Variable_Name"] = value.Condition_Name
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Skill_Ready"]) > 0 then
        self.skills = true
        valuebar.rewrittenConditionsTable["EvenVariable"] = {}
        for key, value in pairs(data["Skill_Ready"]) do
            valuebar.rewrittenConditionsTable["EvenVariable"][key] = {
                ["Not_Applied"] = value.Not_Applied,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Class_Resource_Threshold"]) > 0 then
        valuebar.rewrittenConditionsTable["Resource"] = {}
        for key, value in pairs(data["Class_Resource_Threshold"]) do
            valuebar.rewrittenConditionsTable["Resource"][key] = {
                ["Comparator"] = value.Comparator,
                ["Threshold"] = value.Number,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Morale_Threshold"]) > 0 then
        valuebar.rewrittenConditionsTable["Morale"] = {}
        for key, value in pairs(data["Morale_Threshold"]) do
            valuebar.rewrittenConditionsTable["Morale"][key] = {
                ["Threshold"] = value.Number,
                ["Comparator"] = value.Comparator,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Power_Threshold"]) > 0 then
        valuebar.rewrittenConditionsTable["Power"] = {}
        for key, value in pairs(data["Power_Threshold"]) do
            valuebar.rewrittenConditionsTable["Power"][key] = {
                ["Threshold"] = value.Number,
                ["Comparator"] = value.Comparator,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Fight"]) > 0 then
        valuebar.rewrittenConditionsTable["Fight"] = {}
        for key, value in pairs(data["Fight"]) do
            valuebar.rewrittenConditionsTable["Fight"][key] = {
                ["Boss_Name"] = value.Boss_Name,
                ["Tier_Info"] = value.Tier_Info,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["FightPhase"]) > 0 then
        valuebar.rewrittenConditionsTable["FightPhase"] = {}
        for key, value in pairs(data["FightPhase"]) do
            valuebar.rewrittenConditionsTable["FightPhase"][key] = {
                ["Boss_Name"] = value.Boss_Name,
                ["Tier_Info"] = value.Tier_Info,
                ["Phase"] = value.Phase,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Level"]) > 0 then
        valuebar.rewrittenConditionsTable["Level"] = {}
        for key, value in pairs(data["Level"]) do
            valuebar.rewrittenConditionsTable["Level"][key] = {
                ["Threshold"] = value.Number,
                ["Comparator"] = value.Comparator,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Lock"]) > 0 then
        valuebar.rewrittenConditionsTable["Lock"] = {}
        for key, value in pairs(data["Lock"]) do
            valuebar.rewrittenConditionsTable["Lock"][key] = {
                ["Not_Applied"] = value.Not_Applied,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    if tablelength(data["Quest"]) > 0 then
        valuebar.rewrittenConditionsTable["Quest"] = {}
        for key, value in pairs(data["Quest"]) do
            valuebar.rewrittenConditionsTable["Quest"][key] = {
                ["Not_Applied"] = value.Not_Applied,
            }
            thresholdNumber = thresholdNumber + 1
        end
    end

    local ConditionToken = string.format("PrimeUIConditionObject%s%s", self.name, data.Order)
    ConditionHandler:AddCondition({
        ["Name"] = ConditionToken,
        ["Threshold"] = data.Use_Specific_Threshold_Number and data.Specific_Threshold_Number or thresholdNumber,
        ["Conditions"] = valuebar.rewrittenConditionsTable
    }, valuebar.togglefunction)

    table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
    function(event)
        ConditionHandler:FireTrigger(event, self.args[event], ConditionToken)
    end))

    valuebar.Unload = function()
    end

    --PrintTable(valuebar.rewrittenConditionsTable)

    self.conditionTokens[ConditionToken] = true

    table.insert(self.tools, valuebar)
end