function PrimeUI:SetupTargetMoraleBar(data, parent)
    local valuebar = Turbine.UI.Window()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Target Morale Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))
    valuebar:SetVisible(false)

    local colour = self:ColourTupleToTurbineColour(data["Colours"])
    if data.Use_Class_Colours then
        local ClassColours = {
            [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(77/255, 38/255, 0), --Yellow
            [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0, 255/255, 152/255), 
            [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(255/255, 244/255, 104/255), --Yellow
            [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(244/255, 140/255, 186/255), --Pink
            [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
            [(Turbine.Gameplay.Class.Mariner or Turbine.Gameplay.Class.Corsair or Turbine.Gameplay.Class.Chicken)] = Turbine.UI.Color(0, 63/255, 63/255), --Brownrgb(204, 153, 102)
            [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(100/255, 0/255, 0/255), --Red
            [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(170/255, 211/255, 114/255), --{Turbine.UI.Color(51/255, 102/255, 0)
            [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(135/255, 136/255, 238/255), --Purple
            [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0, 60/255, 200/255), --Light green
            [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
            [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(255/255, 102/255, 0/255), --Orange
            [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(102/255, 0, 0),
        }
        
        local ClassColoursBackground = {
            [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(0.5, 77/255, 38/255, 0), --Yellow
            [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0.5, 0, 255/255, 152/255), 
            [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(0.3, 255/255, 244/255, 104/255), --Yellow
            [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(0.5, 244/255, 140/255, 186/255), --Pink
            [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(0.5, 198/255, 155/255, 109/255), --Brownrgb(0.5, 204, 153, 102)
            [(Turbine.Gameplay.Class.Mariner or Turbine.Gameplay.Class.Corsair or Turbine.Gameplay.Class.Chicken)] = Turbine.UI.Color(0.5, 0, 63/255, 63/255), --Brownrgb(0.5, 204, 153, 102)
            [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(0.5, 100/255, 0/255, 0/255), --Red
            [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(0.5, 170/255, 211/255, 114/255), --{Turbine.UI.Color(0.5, 51/255, 102/255, 0)
            [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(0.5, 135/255, 136/255, 238/255), --Purple
            [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0.5, 0, 60/255, 200/255), --Light green
            [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(0.5, 63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0.5, 0, 191/255, 1), --{Turbine.UI.Color(0.5, 0, 115/255, 153/255),
            [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(0.5, 255/255, 102/255, 0/255), --Orange
            [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
        }
        colour[2] = ClassColours[self.player:GetClass()]
        colour[1] = ClassColoursBackground[self.player:GetClass()]
    end

    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local moralebar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], colour, "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    self.lookup[data.NickName or ""] = moralebar
    moralebar:SetMaxValue(1)
    moralebar:SetCurrentValue(1)
    moralebar:SetTempValue(0)
    
    if data["Smooth"] then
        table.insert(self.healthTargetCallbacks, TargetHandlerObject:AddHealthCallback(function(value) moralebar:SetCurrentValue(value) end))
    else
        table.insert(self.healthTargetCallbacks, TargetHandlerObject:AddHealthCallback(function(value) moralebar:SetCurrentValueImmediate(value) end))
    end
    table.insert(self.temporaryHealthTargetCallbacks, TargetHandlerObject:AddTemporaryHealthCallback(function(value) moralebar:SetTempValue(value) end))

    table.insert(self.targetInfoCallbacks, TargetHandlerObject:AddTargetInfoCallback(function(value) 
        if value then
            valuebar:SetVisible(true)
            moralebar:SetMaxValue(value["MaxMorale"] or 1)
            moralebar:SetCurrentValueImmediate(value["Morale"] or 1)
            moralebar:SetTempValue(value["TemporaryMorale"] or 0)
        else
            valuebar:SetVisible(false)
        end
    end))

    table.insert(self.UI, valuebar)
    table.insert(self.tools, moralebar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
    self.heightSize = self.heightSize + data["Height"] + 2 * data["BorderSize"]
end