function GenerateResourebarOptions(valuebar, optionsHeight, width)
    valuebar.TriggerBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "From Box #",
            ["Variable"] = "Box_Number",
        }
    })

    optionsHeight = optionsHeight + valuebar.TriggerBox:GetHeight() + 5

    valuebar.UpperBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "To Box #",
            ["Variable"] = "Box_Number",
        }
    })

    optionsHeight = optionsHeight + valuebar.UpperBox:GetHeight() + 5

    valuebar.RedBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Red [1-255]",
            ["Variable"] = "Red_Colour",
        },
    })

    optionsHeight = optionsHeight + valuebar.RedBox:GetHeight() + 5

    valuebar.GreenBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Green [1-255]",
            ["Variable"] = "Green_Colour",
        },
    })

    optionsHeight = optionsHeight + valuebar.GreenBox:GetHeight() + 5

    valuebar.BlueBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Blue [1-255]",
            ["Variable"] = "Blue_Colour",
        },
    })

    optionsHeight = optionsHeight + valuebar.BlueBox:GetHeight() + 5

    return optionsHeight
end

function AddButtonFunctionResourcebar(valuebar, width, triggerType, UIType, func)
    local trigger_result = valuebar.TriggerBox:GetValues()
    local upper_result = valuebar.UpperBox:GetValues()
    local red_result = valuebar.RedBox:GetValues()
    local green_result = valuebar.GreenBox:GetValues()
    local blue_result = valuebar.BlueBox:GetValues()

    if trigger_result.Trigger_Type == "Trigger Type" then
        ThrowException("Failed to add trigger. Trying to add trigger without trigger type.")
        return     
    end

    local triggerEntry = {
        ["Box_Number"] = trigger_result.Box_Number,
        ["Box_Upper"] = upper_result.Box_Number,
        ["Red"] = math.clamp(tonumber(red_result.Red_Colour) or 1, 1, 255),
        ["Green"] = math.clamp(tonumber(green_result.Green_Colour) or 1, 1, 255),
        ["Blue"] = math.clamp(tonumber(blue_result.Blue_Colour) or 1, 1, 255),
    }

    if func(Turbine.Engine.GetGameTime(), triggerEntry) then
        return
    end

    valuebar.listbox:AddItem(CreateTriggerListBoxOptionsListboxItemResourcebar(Turbine.Engine.GetGameTime(), triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
    valuebar.listbox:SetVisible(true)
end

function CreateTriggerListBoxOptionsListboxItemResourcebar(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local optionsHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)
    
    listBoxItem.label = Turbine.UI.Label()
    listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, optionsHeight)
    --listBoxItem.label:SetText(tostring(value.Trigger_Type) .. ": " .. tostring(value.Trigger_Code))
    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    
    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, optionsHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    optionsHeight = optionsHeight + listBoxItem.RemovalButton:GetHeight() + 5

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.options = {}

    listBoxItem.TriggerBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "From Box #",
            ["Variable"] = "Box_Number",
            ["Value"] = value.Box_Number
        }
    })

    optionsHeight = optionsHeight + listBoxItem.TriggerBox:GetHeight() + 5

    listBoxItem.UpperBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "To Box #",
            ["Variable"] = "Box_Number",
            ["Value"] = value.Box_Upper
        }
    })

    optionsHeight = optionsHeight + listBoxItem.UpperBox:GetHeight() + 5

    listBoxItem.RedBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Red [1-255]",
            ["Variable"] = "Red_Colour",
            ["Value"] = value.Red
        },
    })

    listBoxItem.RedBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.RedBox:GetHeight() + 5

    listBoxItem.GreenBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Green [1-255]",
            ["Variable"] = "Green_Colour",
            ["Value"] = value.Green
        },
    })

    listBoxItem.GreenBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.GreenBox:GetHeight() + 5

    listBoxItem.BlueBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Blue [1-255]",
            ["Variable"] = "Blue_Colour",
            ["Value"] = value.Blue
        },
    })

    listBoxItem.BlueBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.BlueBox:GetHeight() + 5

    listBoxItem.InnerBox:SetSize(innerWidth, optionsHeight)
    listBoxItem:SetSize(width, optionsHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local trigger_result = listBoxItem.TriggerBox:GetValues()
        local upper_result = listBoxItem.UpperBox:GetValues()
        local red_result = listBoxItem.RedBox:GetValues()
        local green_result = listBoxItem.GreenBox:GetValues()
        local blue_result = listBoxItem.BlueBox:GetValues()

        local triggerEntry = {
            ["Box_Number"] = trigger_result.Box_Number,
            ["Box_Upper"] = upper_result.Box_Number,
            ["Red"] = math.clamp(tonumber(red_result.Red_Colour) or 1, 1, 255),
            ["Green"] = math.clamp(tonumber(green_result.Green_Colour) or 1, 1, 255),
            ["Blue"] = math.clamp(tonumber(blue_result.Blue_Colour) or 1, 1, 255),
        }

        func(key, triggerEntry) 
    end

    return listBoxItem
end