QuestOptions = class(Turbine.UI.Control)
function QuestOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 550
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height)
    self:SetPosition(0, 0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    self.acceptedBox = Turbine.UI.ListBox()
    self.acceptedBox:SetParent(self)
    self.acceptedBox:SetPosition(0, 0)
    --self.acceptedBox:SetBackColor(Turbine.UI.Color.Goldenrod)
    self.acceptedBox:SetSize(self:GetWidth() / 2 - 10, self:GetHeight())

    self.acceptedBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.acceptedBoxScrollbar:SetParent(self)
    self.acceptedBoxScrollbar:SetPosition(self:GetWidth() / 2 - 10, 0)
    self.acceptedBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.acceptedBoxScrollbar:SetSize(10, self:GetHeight())
    self.acceptedBox:SetVerticalScrollBar(self.acceptedBoxScrollbar)

    self.addListboxQuestItem = function(questName, completions, special)
        local controlBar = Turbine.UI.Control()
        controlBar:SetSize(self.acceptedBox:GetWidth(), 24)
        controlBar:SetBackColor(Turbine.UI.Color.Black)

        controlBar.label = Turbine.UI.Label()
        controlBar.label:SetParent(controlBar)
        controlBar.label:SetPosition(0, 2)
        controlBar.label:SetSize(self.acceptedBox:GetWidth() - 4, 20)
        controlBar.label:SetBackColor(Turbine.UI.Color(0.1,0.14,0.14))
        controlBar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        controlBar.label:SetMarkupEnabled(true)
        controlBar.label:SetText(string.format("%s %s", questName, completions and completions > 0 and string.format("[%s]", completions) or ""))

        if special then
            controlBar.removalButton = Turbine.UI.Lotro.Button()
            controlBar.removalButton:SetParent(controlBar)
            controlBar.removalButton:SetText("Remove")
            controlBar.removalButton:SetPosition(self.acceptedBox:GetWidth() - 50, 0)

            controlBar.removalButton.Click = function()
                QuestHandlerObject:RemoveQuest(questName)
                self.acceptedBox:RemoveItem(controlBar)
            end
            
        end

        return controlBar
    end

    self.completedBox = Turbine.UI.ListBox()
    self.completedBox:SetParent(self)
    self.completedBox:SetPosition(0, 40)
    --self.completedBox:SetBackColor(Turbine.UI.Color.Goldenrod)
    self.completedBox:SetSize(self:GetWidth() / 2 - 10, self:GetHeight())
    self.completedBox:SetPosition(self:GetWidth() / 2, 0)

    self.completedBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.completedBoxScrollbar:SetParent(self)
    self.completedBoxScrollbar:SetPosition(self:GetWidth() - 10, 0)
    self.completedBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.completedBoxScrollbar:SetSize(10, self:GetHeight())
    self.completedBox:SetVerticalScrollBar(self.completedBoxScrollbar)

    self.hasItems = false

    self.VisibleChanged = function()
        if self:IsVisible() and not self.hasItems then
            self.hasItems = true
            local acceptedQuests = QuestHandlerObject:GetAllAcceptedQuests()
            if acceptedQuests then
                for key, value in pairs(acceptedQuests) do
                    self.acceptedBox:AddItem(self.addListboxQuestItem(key, -1, true))
                end
            end

            local completedQuests = QuestHandlerObject:GetAllCompletedQuests()
            if completedQuests then
                for key, value in pairs(completedQuests) do
                    self.completedBox:AddItem(self.addListboxQuestItem(key, value.Completed, false))
                end
            end
        else
            self.hasItems = false
            if not self:IsVisible() then
                self.completedBox:ClearItems()
                self.acceptedBox:ClearItems()
            end

        end
    end
end