BoxTimer = class(Turbine.UI.Window)
function BoxTimer:Constructor(parent, colour)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(false)
    --self:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self:SetBackColor(colour or Turbine.UI.Color.White)
    self:SetSize(14, 14)

    self.backgroundControl = Turbine.UI.Control()
    self.backgroundControl:SetParent(self)
    self.backgroundControl:SetSize(self:GetSize())
    --self.backgroundControl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.backgroundControl:SetBackColor(colour or Turbine.UI.Color.White)
    self.backgroundControl:SetStretchMode(1)

    self.baseImageID = 0x41007E35
    self.scale = 1
    self.width = 32
    self.height = 32
    self.borderSize = 0

    self.elapsedOverlay = Turbine.UI.Control()
    --self.elapsedOverlay:SetStretchMode( 1 )
    self.elapsedOverlay:SetMouseVisible( false )
    --self.elapsedOverlay:SetZOrder( 99 )
    self.elapsedOverlay:SetBackColor(Turbine.UI.Color.Black)
    --self.elapsedOverlay:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.elapsedOverlay:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.elapsedOverlay:SetParent( self.backgroundControl )
    self.elapsedOverlay:SetPosition(-7, -7)
    self.elapsedOverlay:SetSize(self.width, self.height)
    self.elapsedOverlay:SetMouseVisible(false)

    self.duration = 0
    self.maxDuration = 0
end

function BoxTimer:Start(timer)
    self.duration = timer
    self.maxDuration = timer

    self:SetVisible(true)
    self.elapsedOverlay:SetVisible(true)
    self.backgroundControl:SetVisible(true)

    self.updateCallback = AddCallback(Updater, "ExecuteUpdate", function(delta)
        self.duration = self.duration - delta

        local imageId = self.baseImageID + math.floor(60 * (self.duration / self.maxDuration))
        
        self.elapsedOverlay:SetVisible(true)
        self.elapsedOverlay:SetStretchMode(nil)
        self.elapsedOverlay:SetSize(32, 32)
        self.elapsedOverlay:SetBackground(imageId)
        --self.elapsedOverlay:SetStretchMode(1)
        self.elapsedOverlay:SetSize(self.width , self.height)

        if self.duration < 0 then
            if self.updateCallback then
                RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback)
                self.updateCallback = nil
            end

            self:SetVisible(false)
            self.elapsedOverlay:SetVisible(false)
            self.backgroundControl:SetVisible(false)
        end
    end)
end